<?php 

//include( $_SERVER['DOCUMENT_ROOT'].substr($_SERVER['PHP_SELF'], 0, strpos($_SERVER['PHP_SELF'], "/", 1)).'/configuration.php' );
//require_once( $_SERVER['DOCUMENT_ROOT'].substr($_SERVER['PHP_SELF'], 0, strpos($_SERVER['PHP_SELF'], "/", 1)).'/core/logger.php' );

class fileSystemManager {

	// Upload the selected file
	public static function uploadFile($tmpPath, $destinationFolder , $fileName){
		
		if (!move_uploaded_file($tmpPath, $destinationFolder . $fileName))
		{
		   	return false;
		}
		return true;
		
	}
	
	// Verify if the type of the file uploaded is correct
	public static function verifyFileType($file, $type){

		if (strcmp($_FILES[$file]['type'],$type))
		{
		   	return false;
		}
		return true;
		
	}
	
	// Verify if the type of the file uploaded is correct
	public static function verifyGenericFileType($file, $genericType){
		//logger::write($_FILES[$file]['type']);
		if (strpos($_FILES[$file]['type'],$genericType) === FALSE)
		{
			return false;
		}
		return true;
		
	}
	
	//Copy and rename a file in the same directory
	public static function copyAndRenameFile($oldFile, $newName)
	{

		if(!@copy($oldFile, fileSystemManager::getFolderPath($oldFile).$newName))
		{
			die("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error during the copy/creation of the new file</h3></div>");
		}	
		return true;
		
	}
	
	// The function substitute the content of arrayOldString with the content of arrayNewString in the line of arrayLineString
	public static function subStrInFile($filePath, $arrayOldStr, $arrayNewStr, $arrayLineStr)
	{
		
		// Verify if the len of the arrays is the same
		if ( !(sizeof($arrayOldStr)+sizeof($arrayNewStr) == sizeof($arrayLineStr)*2))
			die("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error: fileSystemManager::subStrInFile - The len of the arrays is different!!</h3></div>");
		
		if ( !@$configFile = file($filePath) )
			die("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error: fileSystemManager::subStrInFile - The file specified doesn't exist!!</h3></div>");
		$handle = fopen($filePath, 'w');
		$element = sizeof($arrayLineStr);
		
		foreach ($configFile as $line_num => $line){
			//Preprocess the string for Machintosh compatibility
			$line = rtrim($line,"\r\n");
			
			$flag = 0;
			for ($i=0; $i < $element; $i++) { 
				if ( !strcmp(substr($line,0,16),$arrayLineStr[$i]))
				{
					fwrite($handle, str_replace($arrayOldStr[$i], $arrayNewStr[$i], $line."\r\n"));
					//echo $arrayNewStr[$i]."<br/>";
					$flag = 1;
				}					
			}
			if (!$flag)
				fwrite($handle, $line."\r\n");
		}
		
		fclose($handle);
		
	}

	//Read the content of a file in a string
	public static function readFileString($filePath)
	{
		
		if ( !@$stringContent = readfile($filePath) )
			die("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error: fileSystemManager::readFileString - The file specified doesn't exist!!</h3></div>");
		return $stringContent;
		
	}
	
	//Return the path of a file, without the name of the file itself
	private static function getFolderPath($path)
	{
		
		$len = strlen($path);
		for ($i=0; $i < $len; $i++) { 
			$letter = substr($path,-1);
			if ($letter == '/')
				return($path);
			else
				$path = substr($path,0,-1);
		}	
		
	}
	
	
	//Create new directory
	
	public static function create_dirs($path)
	{
	  if (!is_dir($path))
	  {
	    $directory_path = "";
	    $directories = explode("/",$path);
	    array_pop($directories);

	    foreach($directories as $directory)
	    {
	      $directory_path .= $directory."/";
	      if (!is_dir($directory_path))
	      {
	        mkdir($directory_path);
	        chmod($directory_path, 0777);
	      }
	    }
	  }
	}
	
	
	
	public static function deleteFilesAndFolder($folderName){
		
		$elenco=array();
		
		$cartella = opendir($folderName);
		
		while ($file = readdir($cartella)) {
			
			if($file !='.' && $file !='..'){
				
				if(is_file($folderName.'/'.$file)){
					
					array_push($elenco,$folderName.'/'.$file);
					
					unlink($folderName.'/'.$file);
				}
			
				if(is_dir($folderName.'/'.$file)){
					
					$elenco = fileSystemManager::myMerge($elenco,fileSystemManager::deleteFilesAndFolder($folderName.'/'.$file));
				}
			}
		}
		
		closedir($cartella);
		
		rmdir($folderName);
		
		array_push($elenco,$folderName);

		
		return $elenco;

	}
	
	private static function myMerge($array1,$array2){
		foreach($array2 as $a){
			array_push($array1,$a);
		}
		return $array1;
	}
	
	public static function SearchMetaNameInFile($filePath)
	{
		$temp_array=array();
		$meta =array();
		$meta_str= "\$site_meta_";
		if ( !@$configFile = file($filePath) )
			die("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error: fileSystemManager::subStrInFile - The file specified doesn't exist!!</h3></div>");
		$handle = fopen($filePath, 'r');
		$element = count($configFile);
		foreach ($configFile as $line_num => $line)
		{
			//Preprocess the string for Machintosh compatibility
			$line = rtrim($line,"\r\n");
			if ( !strcmp(substr($line,0,11),$meta_str))
			{
				//echo 'ciao' ;
				list($meta_name,$meta_content) = explode("=",$line);
				ltrim($meta_name);
				ltrim($meta_content);
				rtrim($meta_name);
				rtrim($meta_content);
				$metaname = substr($meta_name, 1);				
				$temp_array = array(
								'meta_name'=>$meta_name,	
								'meta_content'=>$meta_content								
								);
				array_push($meta , $temp_array);
			}
			
										
		}
		
		echo'<br>';
		print_r ($meta);
		
		foreach ($meta as $element)
		{
		print_r ($element['meta_name']);
		}
		
		fclose($handle);
		
	}

}

?>