<?php

#
# core / da.php
#
# this file contains all IDM business logic and transition/navigation logic.
#

include ( 'core/renderer.php' );		// HTML renderer
include ( 'core/navigator.php' );		// menu manager
include ('core/error.php');


class DialogueAct 
{

	// A Dialogue act is made of 
	// 1. Concept (in IDM Schema)
	// 2. Instance (in DB)
	private $da_s_DB = array(
							'id' => '',
							'idm_name' => '',
							'is_default' => '',
							's_topic_id' => '',
							 );
							 
	private $da_c_DB = array(
							'id' => '',
							's_dialogue_act_id' => '',
							'c_topic_id' => '',
							'label' => '',
							'status' => ''
							);
							

	// Dialogue Act Structural Links
	private $structuralLinks = array();
	
	// Dialogue Act Transition Links 
	private $transitionLinks = array();
	private $transitionActInfo = array();
	
	private $m_topic_id;
	
	
	
	// ------------------------------------------------------------------------------------------------------ __construct()
	public function __construct($id, $language, $m_topic, $smarty) 
	{	
		$this->m_topic_id = $m_topic;
		$query =  "SELECT s_topic_id ";
		$query .= "FROM _TABLEPREFIX_s_dialogue_act ";
		$query .= "WHERE id = '".$id."'";
		$result = DBManager::exeQuery($query); //static method
		$row = mysql_fetch_array($result);
		$s_topic_id = $row['s_topic_id'];	
		if(!is_numeric ($this->m_topic_id))
		{
			$query =  "SELECT id ";
			$query .= "FROM _TABLEPREFIX_c_topic ";
			$query .= "WHERE s_topic_id = '".$s_topic_id."' AND c_language_id = '".$language."'";
			$result = DBManager::exeQuery($query); //static method
			$row = mysql_fetch_array($result);
			$c_topic_id = $row['id'];	
		}
		else
		{
			$query =  "SELECT * ";
			$query .= "FROM _TABLEPREFIX_c_topic ";
			$query .= "WHERE s_topic_id = '".$s_topic_id."' AND m_topic_id='".$m_topic."'AND c_language_id = '".$language."'";
			$result = DBManager::exeQuery($query); //static method
			$row = mysql_fetch_array($result);
			$c_topic_id = $row['id'];	
		}
		
		
		$query =  "SELECT id ";
		$query .= "FROM _TABLEPREFIX_c_dialogue_act ";
		$query .= "WHERE s_dialogue_act_id = '".$id."' AND c_topic_id = '".$c_topic_id."' ";

		$result = DBManager::exeQuery($query); //static method
		$row = mysql_fetch_array($result);
		$id = $row['id'];
		// check if DA is active at DB
		
		if (!$this->DAisValid($id)) 
		{
			// Dialogue act is not in DB or it is present but checked as "inactive"
			// Abort operations, redirect to error page..
			$err_msg = "Dialogue act is not in DB or it is present but checked as inactive";
			error::display_error_message($smarty, $err_msg);
			exit;
		}
		
		//execute a query to obtain the information related to the content of the dialogue act
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_dialogue_act ";
		$query .= "WHERE id = '".$id."' ";
		$result = DBManager::exeQuery($query);
		
		//insert the data related to the content of the dialogue act in the array ($da_c_DB)
		$row = mysql_fetch_array($result);
			$this->da_c_DB['id'] = $row['id'];
			$this->da_c_DB['s_dialogue_act_id'] = $row['s_dialogue_act_id'];
			$this->da_c_DB['c_topic_id'] = $row['c_topic_id'];
			$this->da_c_DB['label'] = $row['label'];
			$this->da_c_DB['status'] = $row['status'];
				
		//execute a query to obtain the information related to the schema of the dialogue act
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_dialogue_act ";
		$query .= "WHERE id = '".$this->da_c_DB['s_dialogue_act_id']."' ";
		
		$result = DBManager::exeQuery($query);
		//insert the data related to the schema of the dialogue act in the array ($da_s_DB)
		$row = mysql_fetch_array($result);
			$this->da_s_DB['id'] = $row['id'];
			$this->da_s_DB['idm_name'] = $row['idm_name'];
			$this->da_s_DB['is_default'] = $row['is_default'];
			$this->da_s_DB['s_topic_id'] = $row['s_topic_id'];
		
		// init Structural Links
		$this->fillStructuralLinks();
		
		// init Transition Links
		$this->fillTransitionLinks($language, $smarty);
		
		// fill content
		//$this->fillDBItems();
	}
	
	// ------------------------------------------------------------------------------------------------------ DAisValid()
	public function DAisValid ($da_id){

		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_dialogue_act ";
		$query .= "WHERE id = '".$da_id."' AND status = 'active'";

		$result = DBManager::exeQuery($query);
		if (mysql_num_rows($result) == 1) {
			return true;
		} else return false;
	}
	
	// ------------------------------------------------------------------------------------------------------ fillStructuralLinks()
	public function fillStructuralLinks () {
	
		$temp_array = array();	
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_dialogue_act as t1, ";
		$query .= "_TABLEPREFIX_c_dialogue_act as t2 ";
		$query .= "WHERE t1.id=t2.s_dialogue_act_id AND ";
		$query .= "c_topic_id = '".$this->da_c_DB['c_topic_id']."'";
		$query .= "AND status = 'active' ORDER BY `order`";
		
		$result = DBManager::exeQuery($query);
		while ($row = mysql_fetch_array($result))
		{
			if(!is_numeric ($this->m_topic_id))
				$url = "?da=".$row['s_dialogue_act_id'];
			else
				$url = "?da=".$row['s_dialogue_act_id']."&mt_id=".$this->m_topic_id;
			$isCurrent = false;
			if ($row['id'] == $this->da_c_DB['id']) 
			{
				$isCurrent = true;
			}
			
			$temp_array[$row['id']] = array(
							'label' => $row['label'], 
							'url'   => $url,
							'current' => $isCurrent,
							);
									

										
		}
		$this->structuralLinks = array_merge($this->structuralLinks, $temp_array);
	}
	
	// ------------------------------------------------------------------------------------------------------ fillTransitionLinks()
	public function fillTransitionLinks ($language, $smarty) 
	{
	include( $_SERVER['DOCUMENT_ROOT'].substr($_SERVER['PHP_SELF'], 0, strpos($_SERVER['PHP_SELF'], "/", 1)).'/configuration.php' );	
		// 2 cases: 
		// a. pattern is set to "direct_transition"
		// b. pattern is set to "transition_act"
			
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_transition_act ";
		$query .= "WHERE from_s_topic_id = '".$this->da_s_DB['s_topic_id']."' ";
		
		$result = DBManager::exeQuery($query);
		
		// if no result.. exit
		if (mysql_affected_rows() == 0) 
		{
			return;
		}
		
		// 3. switch between direct_transition / transition_Act pattern to create links
		while ($row = mysql_fetch_array($result))
		{
			$temp_array = array ();	
			$temp_array1 = array ();
			$temp_array2 = array ();	
			$temp_array3 = array ();			
			$idm_name = $row['idm_name'];

				$query =  "SELECT * ";
				$query .= "FROM _TABLEPREFIX_c_transition_act ";
				$query .= "WHERE s_transition_act_id = '".$row['id']."' ";
				$query .= "AND c_language_id = '".$language."'";
				$query .= "AND status= 'active'";
				$result1 = DBManager::exeQuery($query);
				$row1 = mysql_fetch_array($result1);
				$relation_title = $row1['label'];
				$introductory_text = $row1['introductory_text'];
				if ($row['mode'] == 'direct_transition') 
				{
					$mode = "direct_transition";
					$url ="";
				}
				elseif ($row['mode'] == 'transition_act') 
				{
					$mode = "transition_act";
					$url = '?ta='.$row['id'].'';
				}	
				$temp_array3[$idm_name] = array(
											'relation_title' => $relation_title, 
											'mode'   => $mode,
											'introductory_text' => $introductory_text,
											'url' => $url,
											'from_topic_id'=> $this->da_c_DB['c_topic_id']
											);

				$query =  "SELECT * ";
				$query .= "FROM _TABLEPREFIX_c_topic2topic ";
				$query .= "WHERE c_transition_act_id = '".$row1['id']."' ";
				$query .= "AND from_c_topic_id = '".$this->da_c_DB['c_topic_id']."'";
				$query .= "ORDER BY `order` ASC";
				$result2 = DBManager::exeQuery($query);
				
				if (mysql_num_rows($result2)==0)
				{
					if(!strcmp($site_transition_behaviour,"hide"))
					{
						$temp_array3[$idm_name] =array();
						$this->transitionActInfo = array_merge($this->transitionActInfo, $temp_array3);
					}
					elseif(!strcmp($site_transition_behaviour,"show"))
						$this->transitionActInfo = array_merge($this->transitionActInfo, $temp_array3);
				}
				else
					$this->transitionActInfo = array_merge($this->transitionActInfo, $temp_array3);
				$result2 = DBManager::exeQuery($query);
				while ($row2 = mysql_fetch_array($result2))
				{
					// get Multiple Topic Name
					$mt = new MultipleTopic($row2['to_c_topic_id'], $smarty);
					$label = $mt->getName();
					$item=$row2['to_c_topic_id'];
					$url = "?mt=".$row2['to_c_topic_id']."&direct=true";
					$temp_array = array();
					$temp_array[$item] = array(
												'url' => $url, 
												'label'   => $label,
												);
					$temp_array1 = array_merge($temp_array1, $temp_array);	
					
				}
				$temp_array2[$idm_name] = $temp_array1;	
				$this->transitionLinks = array_merge($this->transitionLinks, $temp_array2);
			
		}
	}	
	// ------------------------------------------------------------------------------------------------------ getST()
	public function getST($language, $smarty) 
	{
		return new SingleTopic($this->da_s_DB['s_topic_id'], $language, $smarty);
	}
	
	// ------------------------------------------------------------------------------------------------------ getItemTypes()

	
	public function getItemTypes()
	{
		$items = array();
			
		$query =  "SELECT distinct item_type ";
		$query .= "FROM _TABLEPREFIX_s_item ";
		$query .= "WHERE s_dialogue_act_id = '".$this->da_s_DB['id']."'";
		
		$result = DBManager::exeQuery($query);

		while ($row = mysql_fetch_array($result))
		{
			$temp_array = array(
								$row['item_type'],									
								);
			$items  = array_merge($items , $temp_array);
		}
		return $items;
	}
	
		// get the label of the current DA used to print the title of the page ------------------------------------------------------------------------------------------------------ getLabelDA()
	public function getLabelDA() 
	{
		$query =  "SELECT label ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE id = '".$this->da_c_DB['c_topic_id']."'";
		
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_array($result);
		return $row['label'];
	}
	
			// get the title of the current DA used to print the title of the dialogue act ------------------------------------------------------------------------------------------------------ getTitleDA()
	public function getTitleDA() 
	{
		$query =  "SELECT label ";
		$query .= "FROM _TABLEPREFIX_c_dialogue_act ";
		$query .= "WHERE c_topic_id = '".$this->da_c_DB['c_topic_id']."' AND s_dialogue_act_id = '".$this->da_c_DB['s_dialogue_act_id']."'";
		
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_array($result);
		return $row['label'];
	}

	// ------------------------------------------------------------------------------------------------------ getidDA() 
	public function getidDA() 
	{
		return $this->da_c_DB['id'];
	}
		// ------------------------------------------------------------------------------------------------------ getMTopicId() 
	public function getMTopicId() 
	{
		if(is_numeric($this->m_topic_id))
		{
			return $this->m_topic_id;
		}
		else
		{
			return NULL;
		}
	}
	
			// ------------------------------------------------------------------------------------------------------ get_c_topic_id()
	public function get_c_topic_id() 
	{
		return $this->da_c_DB['c_topic_id'];
	}
	// ------------------------------------------------------------------------------------------------------ getStructuralLinks()
	public function getStructuralLinks(){
		return $this->structuralLinks;
	}
		
		// ------------------------------------------------------------------------------------------------------ get_topic_id()
	public function get_topic_id()
	{
		return $this->da_s_DB['s_topic_id'];
	}
		
	// ---------------------------------------------------------------------------------------------------- getTransitionLinks()
	public function getTransitionLinks(){
		return $this->transitionLinks;
	}

	// ---------------------------------------------------------------------------------------------------- getTransitionActInfo()
	public function getTransitionActInfo(){
		return $this->transitionActInfo;
	}

	// ------------------------------------------------------------------------------------------------------ renderItems()
	
	public function renderItems($smarty)
	{
		$page_item = array();
		$da_element=$this->da_c_DB['id'];
		$itemTypes = $this->getItemTypes();
		$mt_id = $this->m_topic_id;
		foreach ($itemTypes as $item)
		{
			switch($item) 
			{
				case "htmlText":
					$temp_array[$item] = Renderer::renderItemHtmlText($da_element, $mt_id, $smarty);	
					$page_item = array_merge($page_item, $temp_array);
					break;
					
				case "url": 
					$temp_array[$item] = Renderer::renderItemUrl($da_element, $mt_id, $smarty);	
					$page_item = array_merge($page_item, $temp_array);
					break;
				
				case "image": 
					$temp_array[$item] = Renderer::renderItemImage($da_element, $mt_id, $smarty);
					$page_item = array_merge($page_item, $temp_array);
					break;

				case "audio": 
					$temp_array[$item] = Renderer::renderItemAudio($da_element, $mt_id, $smarty);	
					$page_item = array_merge($page_item, $temp_array);
					break;
									
				case "video": 
					$temp_array[$item] = Renderer::renderItemVideo($da_element, $mt_id, $smarty);	
					$page_item = array_merge($page_item, $temp_array);
					break;
									
				default:
					break;
			}
		}
		return $page_item;
	}
}


class TransitionAct 
{
	private $ta_s_DB = array(
						'id' => '',
						'idm_name' => '',
						'from_s_topic_id' => '',
						'to_s_topic_id' => '',
						'from_cardinality' => '',
						'to_cardinality' => '',
						'has_introduction' => '',
						'mode' => '',
						'navigation_pattern' => ''
						);
	
	private $ta_c_DB = array(
						'id' => '',
						's_transition_act_id' => '',
						'c_language_id' => '',
						'label' => '',
						'introductory_text' => '',
						'status' => ''
						);

	private $transitionLinks = array();
	
	// ------------------------------------------------------------------------------------------------------ __construct()
	public function __construct($id, $language, $mt_id, $smarty) 
	{
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_transition_act ";
		$query .= "WHERE id = '".$id."' ";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_array($result);
		
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_transition_act ";
		$query .= "WHERE s_transition_act_id = '".$row['id']."' ";
		$query .= "AND c_language_id = '".$language."'";
		$result1 = DBManager::exeQuery($query);
		$row1 = mysql_fetch_array($result1);
		$int_id = $row1['id'];
		
		if (!$this->TAisValid($int_id)) 
		{
			// Transition act is not in DB.
			// Abort operations, redirect to error page..
			$err_msg ="This transition act is not in DB or it is present but checked as inactive";
			error::display_error_message($smarty, $err_msg);
			exit;
		}
		
		//fill all the element related to the schema of the current transition act
		$this->ta_s_DB['idm_name'] = $row['idm_name'];
		$this->ta_s_DB['from_s_topic_id'] = $row['from_s_topic_id'];
		$this->ta_s_DB['to_s_topic_id'] = $row['to_s_topic_id'];
		$this->ta_s_DB['from_cardinality'] = $row['from_cardinality'];
		$this->ta_s_DB['to_cardinality'] = $row['to_cardinality'];
		$this->ta_s_DB['has_introduction'] = $row['has_introduction'];
		$this->ta_s_DB['mode'] = $row['mode'];
		$this->ta_s_DB['navigation_pattern'] = $row['navigation_pattern'];
		
		//fill all the element related to the data of the current transition act
		$this->ta_c_DB['id'] = $row1['id'];
		$this->ta_c_DB['s_transition_act_id'] = $row1['s_transition_act_id'];
		$this->ta_c_DB['c_language_id'] = $row1['c_language_id'];
		$this->ta_c_DB['label'] = $row1['label'];
		$this->ta_c_DB['introductory_text'] = $row1['introductory_text'];
		$this->ta_c_DB['status'] = $row1['status'];

		$this->fillTransitionLinks($mt_id, $smarty, $language );
	}

	// ------------------------------------------------------------------------------------------------------ TAisValid()
	public function TAisValid ($ta_id)
	{
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_transition_act ";
		$query .= "WHERE id = '".$ta_id."' ";
		$query .= "AND status= 'active'";

		$result = DBManager::exeQuery($query); //static method
		if (mysql_num_rows($result) == 1) 
			return true;
		else 
			return false;
	}

	
	public function fillTransitionLinks($mt_id, $smarty,$language)
	{
	// da sistemare .....l'mt_id deve essere l's_topic_id della tabella c_topic
	
	
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE id = '".$mt_id."' ";
		$result = DBManager::exeQuery($query);
		$row_topic = mysql_fetch_array($result);		

		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE s_topic_id = '".$row_topic['s_topic_id']."' ";
		$query .= "AND m_topic_id = '".$row_topic['m_topic_id']."' ";	
		$query .= "AND c_language_id = '".$language."' ";	
		$result = DBManager::exeQuery($query);
		$row_topic = mysql_fetch_array($result);		

		
	////////////////////	
		
		
		
		
		
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic2topic ";
		$query .= "WHERE c_transition_act_id = '".$this->ta_c_DB['id']."' ";
		$query .= "AND from_c_topic_id = '".$row_topic['id']."'";
		$query .= "ORDER BY `order` ASC";
		$result = DBManager::exeQuery($query);
		$temp_array = array();
		while ($row = mysql_fetch_array($result))
		{
			// get Multiple Topic Name
			$mt = new MultipleTopic($row['to_c_topic_id'], $smarty);
			$label = $mt->getName();
			$item=$row['to_c_topic_id'];
			$url = "?mt=".$row['to_c_topic_id'];
			$temp_array[$item] = array(
										'url' => $url, 
										'label'   => $label,
										);
			
		}
		
		$this->transitionLinks = array_merge($this->transitionLinks, $temp_array);
	
	}

	public function get_transition_act_id()
	{
		return $this->ta_s_DB['id'];
	}
	
	
	public function getName() 
	{
		return $this->ta_c_DB['label'];
		
	}	
	
	public function getIntroductoryText()
	{
		return $this->ta_c_DB['introductory_text'];
		
	}
	
	public function getTransitionLinks()
	{
		return $this->transitionLinks;
	}
}


class MultipleTopic {
	
	//----------------------------
	// A Multiple Topic is made of 
	// 1. Concept (in IDM Schema)
	// 2. Instance (in DB)
	//multiple topic schema information
	
	private $mt_s_DB = array(
							'id' => '',
							'idm_name' => '',
							'topic_type' =>'',
							'navigation_pattern' => '',
							 );
	//multiple topic content information						 
	private $mt_c_DB 	= array(
							'id' => '',
							's_topic_id' => '',
							'm_topic_id' => '',
							'label' => '',
							'c_language_id' =>'',
							'status' => ''
							);
								
	private $globalItems = array();
	
	// ------------------------------------------------------------------------------------------------------ __construct()
	public function __construct($id, $smarty) {	
		
		// check if MT is active at DB
		if (!$this->MTisValid($id)) {
			// Multiple Topic act is not in DB.
			// Abort operations, redirect to error page..
			$err_msg = "Multiple Topic is not in DB or it is present but checked as inactive";
			error::display_error_message($smarty, $err_msg);
			exit;
		}
		
		// init variables
		$this->mt_c_DB['id'] = $id;
		
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE id = '".$id."' ";
		
		$result = DBManager::exeQuery($query);
		
		$row = mysql_fetch_array($result);
		
		$this->mt_c_DB['s_topic_id'] 	= $row['s_topic_id'];
		$this->mt_c_DB['m_topic_id'] 	= $row['m_topic_id'];
		$this->mt_c_DB['label'] 		= $row['label'];
		$this->mt_c_DB['c_language_id'] = $row['c_language_id'];
		$this->mt_c_DB['status'] 		= $row['status'];
		
		//execute a query to obtain the id of the single topic
		$query = "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_topic ";
		$query .= "WHERE id = '".$row['s_topic_id']."' ";
		$result = DBManager::exeQuery($query);
		$row=mysql_fetch_array($result);
		
		$this->mt_s_DB['id'] = $row['id'];
		$this->mt_s_DB['idm_name'] = $row['idm_name'];		
		$this->mt_s_DB['topic_type'] = $row['topic_type'];
		$this->mt_s_DB['navigation_pattern'] = $row['navigation_pattern'];

		//$this->fillGlobalItems();


	}
	
	// ------------------------------------------------------------------------------------------------------ MTisValid()
	public function MTisValid ($mt_id){

		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE id = '".$mt_id."' AND status = 'active' ";
		
		$result = DBManager::exeQuery($query); //static method
		if (mysql_num_rows($result) == 1) {
			return true;
		} else return false;
	}
	
	public function getName() {
		return $this->mt_c_DB['label'];
	}


	/*public function fillGlobalItems(){
		
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_items ";
		$query .= "WHERE topic_id = '".$this->mt_DB['id']."' AND status = 'active' ";
		$result = DBManager::exeQuery($query); //static method
		
		while ($row = mysql_fetch_array($result)) {

			
			$temp_item = array(				// array to handle REAL contents of DA
							'id' => '',
							'idm_name' => '',	
							'dialogueact_id' => '',	
							'topic_id' => '',
							'type_id' => '',	
							'status' => ''
							);
							
			$temp_item['id'] = $row['id'];
			$temp_item['idm_name'] = $row['idm_name'];
			$temp_item['dialogueact_id'] = $row['dialogueact_id'];
			$temp_item['topic_id'] = $row['topic_id'];
			$temp_item['type_id'] = $row['type_id'];
			$temp_item['status'] = $row['status'];
			
			array_push ($this->globalItems, $temp_item); 
		}
	}

	
	// ====================================                =======
	// ==================================== RENDER CONTENT =======
	// ====================================                =======
	
	public function renderGlobalItems(){
		$output = '';
		
		foreach ($this->globalItems as $item){
			switch($item['type_id']) {
				case '1': 
					$output .= Renderer::renderPlainText($item);
					break; 
				
				case '2':
					
					$output .= Renderer::renderHtmlText($item);
					break; 
				
				case '3': 
					$output .= Renderer::renderUrl($item);
					break; 
				
				case '4': 
				    $output .= Renderer::renderImage($item);
					break; 

				case '5': 
					$output .= Renderer::renderAudio($item);
					break; 
				
				case '6': 
					$output .= Renderer::renderVideo($item);
					break; 

				default: break;
			}
		}
		
		return $output;
	}
	*/

	
	//get the schema id of the current MT
	public function get_topic_id()
	{
		return $this->mt_c_DB['s_topic_id'];
	}
	

	
	
	public function getDefaultDA($language, $smarty){
		//1. get id of the default dialogue act of the IDM schema 
		$query =  "SELECT id ";
		$query .= "FROM _TABLEPREFIX_s_dialogue_act ";
		$query .= "WHERE s_topic_id = '".$this->mt_s_DB['id']."' AND is_default='true'";
		$result = DBManager::exeQuery($query); //static method
		$row = mysql_fetch_array($result);
		$da_id = $row['id'];
		
		
		
		$m_topic_id = $this->mt_c_DB['m_topic_id'];
		return new DialogueAct($da_id, $language,$m_topic_id, $smarty );
	}
}



class SingleTopic {
	
	//----------------------------
	// A Single Topic is made of 
	// 1. Concept (in the DB schema)
	// 2. Instance (in the content DB)
	
	//single topic schema information
	private $ST_s_DB = array(
							'id' => '',
							'idm_name' => '',
							'topic_type' =>'',
							'navigation_pattern' => '',
							 );
	//single topic content information						 
	private $ST_c_DB = array(
							'id' => '',
							's_topic_id' => '',
							'm_topic_id' => '',
							'label' => '',
							'c_language_id' =>'',
							'status' => ''
							);
							
	private $globalItems = array();
	

	
	//-------------- __construct()
	public function __construct($id, $language, $smarty) {	

		$int_id = $id;
		
		//execute a query to obtain the id of the single topic
		$query = "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_topic ";
		$query .= "WHERE id = '".$int_id."' ";
		$result = DBManager::exeQuery($query);
		$row_id=mysql_fetch_array($result);
			
		//execute a query to obtain the information related to the single topic 
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE s_topic_id = '".$row_id['id']."' AND c_language_id= '".$language."' ";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_array($result);
		$int_id = $row['id'];
		
		
		if (!$this->STisValid($int_id)) {
			// Single Topic is not in DB.
			// Abort operations, redirect to error page..
			$err_msg ="This single topic is not in DB or it is present but checked as inactive";
			error::display_error_message($smarty, $err_msg);
			exit;
		}
		
		// init variables
		$this->ST_c_DB['id'] = $int_id;
		
		//Insert the data related to the single topic in the array ($st_c_DB)) 
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE id = '".$int_id."' AND c_language_id= '".$language."' ";
		
		$result = DBManager::exeQuery($query);
		
		$row = mysql_fetch_array($result);
			$this->ST_c_DB['s_topic_id'] 	= $row['s_topic_id'];
			$this->ST_c_DB['m_topic_id'] 	= $row['m_topic_id'];
			$this->ST_c_DB['label'] 		= $row['label'];
			$this->ST_c_DB['c_language_id'] = $row['c_language_id'];
			$this->ST_c_DB['status'] 		= $row['status'];

		//Insert the data related to the schema of the single topic in the array ($ST_s_DB)) 
		$this->ST_s_DB['id'] = $row_id['id'];
		$this->ST_s_DB['idm_name'] = $row_id['idm_name'];		
		$this->ST_s_DB['topic_type'] = $row_id['topic_type'];
		$this->ST_s_DB['navigation_pattern'] = $row_id['navigation_pattern'];


	}

	// ------------------------------------------------------------------------------------------------------ STisValid()
	public function STisValid ($topic_id){
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE id = '".$topic_id."' AND status = 'active' ";

		$result = DBManager::exeQuery($query); //static method
		if (mysql_num_rows($result) == 1) {
			return true;
		} else return false;
	}


	
	public function get_topic_id(){
		return $this->ST_s_DB['id'];
	}


	public function getDefaultDA($language, $smarty)
	{
	
		//1. get id of the default dialogue act of the IDM schema 
		$query =  "SELECT id ";
		$query .= "FROM _TABLEPREFIX_s_dialogue_act ";
		$query .= "WHERE s_topic_id = '".$this->ST_s_DB['id']."' AND is_default='true'";
		$result = DBManager::exeQuery($query); //static method
		$row = mysql_fetch_array($result);
		$da_id = $row['id'];
		
		return new DialogueAct($da_id, $language, '', $smarty);
	}
	
	public function getGlobalItemTypes()
	{
		$items = array();
			
		$query =  "SELECT distinct item_type ";
		$query .= "FROM _TABLEPREFIX_s_item ";
		$query .= "WHERE s_topic_id = '".$this->ST_s_DB['id']."'";
		
		$result = DBManager::exeQuery($query);

		while ($row = mysql_fetch_array($result))
		{
			$temp_array = array(
								$row['item_type'],									
								);
			$items  = array_merge($items , $temp_array);
		}
		return $items;
	}
	
	

	
	// ====================================                =======
	// ==================================== RENDER CONTENT =======
	// ====================================                =======
	
	public function renderGlobalItems($smarty, $mt_id, $language)
	{
		$topic_item = array();
		$topic_element=$this->ST_c_DB['id'];
		$s_topic_id = $this->ST_s_DB['id'];
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_topic ";
		$query .= "WHERE id = '".$s_topic_id."'";
		$result = DBManager::exeQuery($query); //static method
		$row = mysql_fetch_array($result);
		if ($row['topic_type'] =="mt")
		{
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_topic ";
		$query .= "WHERE s_topic_id = '".$s_topic_id."' AND m_topic_id= '".$mt_id."' ";
		$query .= "AND c_language_id ='".$language."'";
		$result1 = DBManager::exeQuery($query); //static method
		$row1 = mysql_fetch_array($result1);
		$topic_element = $row1['id'];
		}
		$itemTypes = $this->getGlobalItemTypes();
		foreach ($itemTypes as $item)
		{
			switch($item) 
			{
					case "htmlText":

					$temp_array[$item] = Renderer::renderGlobalItemHtmlText($topic_element, $this->ST_c_DB['m_topic_id'], $smarty);	
					$topic_item = array_merge($topic_item, $temp_array);
					break;
					
				case "url": 
					$temp_array[$item] = Renderer::renderGlobalItemUrl($topic_element, $this->ST_c_DB['m_topic_id'], $smarty);	
					$topic_item = array_merge($topic_item, $temp_array);
					break;
				
				case "image": 
					$temp_array[$item] = Renderer::renderGlobalItemImage($topic_element, $this->ST_c_DB['m_topic_id'], $smarty);
					$topic_item = array_merge($topic_item, $temp_array);
					break;

				case "audio": 
					$temp_array[$item] = Renderer::renderGlobalItemAudio($topic_element, $this->ST_c_DB['m_topic_id'], $smarty);	
					$topic_item = array_merge($topic_item, $temp_array);
					break;
									
				case "video": 
					$temp_array[$item] = Renderer::renderGlobalItemVideo($topic_element, $this->ST_c_DB['m_topic_id'], $smarty);	
					$topic_item = array_merge($topic_item, $temp_array);
					break;
									
				default:
					break;
			}
		}
		return $topic_item;
	}
}


class IntroductoryAct {
	
	private $ia_s_DB = array(
						'id' => '',
						'idm_name' => '',
						'navigation_pattern' => '',
						'has_introduction' => ''
						);
	
	private $ia_c_DB = array(
						'id' => '',
						's_introductory_act_id' => '',
						'c_language_id' => '',
						'label' => '',
						'introductory_text' => '',
						'status' => ''
						);
	
	private $multipleTopics = array();
	private $typeIntroductoryAct;
	
	// ------------------------------------------------------------------------------------------------------ __construct()
	public function __construct($ia_id, $language, $smarty)
	{
		//execute a query to obtain the information related to the schema of the ia 
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_introductory_act ";
		$query .= "WHERE id = '".$ia_id."'";
		
		$result = DBManager::exeQuery($query);
		$row_id = mysql_fetch_array($result);
		//execute a query to obtain the information related to the content of the ia 
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_introductory_act ";
		$query .= "WHERE s_introductory_act_id = '".$row_id['id']."'";
		$query .= "AND c_language_id= '".$language."' ";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_array($result);
		if (!$this->IAisValid($row['id'])) {
			// Introd. Act is not in DB.
			// Abort operations, redirect to error page..
			$err_msg ="Introductory Act is not in DB or it is present but checked as inactive";
			error::display_error_message($smarty, $err_msg);
			exit;
		}
				

		$this->ia_c_DB['id'] = $row['id'];
		$this->ia_c_DB['s_introductory_act_id'] = $row['s_introductory_act_id'];
		$this->ia_c_DB['c_language_id'] = $row['c_language_id'];
		$this->ia_c_DB['label'] = $row['label'];
		$this->ia_c_DB['introductory_text'] = $row['introductory_text'];
		$this->ia_c_DB['status'] = $row['status'];
	

		//Insert the data related to the schema of the introductory act 
		//in the array ($ia_s_DB)) 
		
		$this->ia_s_DB['id'] = $row_id['id'];
		$this->ia_s_DB['idm_name'] = $row_id['idm_name'];		
		$this->ia_s_DB['navigation_pattern'] = $row_id['navigation_pattern'];
		$this->ia_s_DB['has_introduction'] = $row_id['has_introduction'];

		//fill multiple topics belonging to this introductory act
		$this->fillMultipleTopics($language, $smarty);
		
	
	}
	
	// ------------------------------------------------------------------------------------------------------ STisValid()
	public function IAisValid ($ia_id){

		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_introductory_act ";
		$query .= "WHERE id = '".$ia_id."' AND status = 'active' ";

		$result = DBManager::exeQuery($query); 
	
		if (mysql_num_rows($result) == 1) {
			return true;
		} else return false;
	}
	
	public function displayError ($smarty)
	{
		$err_msg ="This Intoductory act does not have any element";
		error::display_error_message($smarty, $err_msg);
		exit;

	}
	public function fillMultipleTopics($language, $smarty)
	{
		$ia_id = $this->ia_s_DB['id'];
		$query =  "SELECT * ";
		$query .= "FROM _TABLEPREFIX_s_introductory_act2topic ";
		$query .= "WHERE s_introductory_act_id = '".$ia_id."'";
		$result = DBManager::exeQuery($query); 		
		//print_r ($row = mysql_fetch_array($result));
		while ($row = mysql_fetch_array($result)) 
		{
			if ($row['s_introductory_act_element_id'] != 0)
			{ 
				$this->typeIntroductoryAct = "parametric";
				
				
				
				$query = "SELECT * ";
				$query .= "FROM _TABLEPREFIX_c_introductory_act2topic AS ia2t JOIN "; 
				$query .= "_TABLEPREFIX_c_introductory_act AS ia ";
				$query .= "ON ia2t.c_introductory_act_id = ia.id ";
				$query .= "WHERE ia.s_introductory_act_id = '".$ia_id."' ";
				$query .= "AND ia.c_language_id= '".$language."' ";
				$query .= "ORDER BY `order` ASC";
				
				$result1 = DBManager::exeQuery($query); 
				if (mysql_num_rows($result1) == 0) 
				$this->displayError ($smarty);
				$parametric=true;
				
				while ($row_ia = mysql_fetch_array($result1)) 
				{
					$query = "SELECT * ";
					$query .= "FROM _TABLEPREFIX_c_introductory_act "; 
					$query .= "WHERE id = '".$row_ia['c_introductory_act_element_id']."' ";
					$result4 = DBManager::exeQuery($query); 
					$row_ia1 = mysql_fetch_array($result4);
					$url = "?ia=".$row_ia1['s_introductory_act_id'];
					$temp_array[$row_ia1['id']] = array(
											'url' => $url, 
											'label'   => $row_ia1['label'],
											);
				}
				break;
			}
			else
			{
				$this->typeIntroductoryAct ="single";
				if ($row['population_type'] == 'all' ) 
				{
					$query =  "SELECT * ";
					$query .= "FROM _TABLEPREFIX_c_topic ";
					$query .= "WHERE s_topic_id = '".$row['s_topic_id']."'";
					$query .= "AND c_language_id = '".$language."' AND status = 'active' ";
					$result2 = DBManager::exeQuery($query); 
					if (mysql_num_rows($result2) != 0) 
					{//$this->displayError ($smarty);
						$all=true;
						
						while ($row_mt = mysql_fetch_array($result2)) 
						{
							$url = "?mt=".$row_mt['id'];
							$temp_array[$row_mt['id']] = array(
												'id' => $row_mt['id'],
												'url' => $url, 
												'label'   => $row_mt['label'],
												);
						}
					}
				}	
				if ($row['population_type'] == 'manual' ) 
				{
					$query =  "SELECT * ";
					$query .= "FROM _TABLEPREFIX_c_introductory_act2topic as ia2t,"; 
					$query .= "_TABLEPREFIX_c_topic as topic ";
					$query .= "WHERE ia2t.c_introductory_act_id = '".$this->ia_c_DB['id']."'";
					$query .= "AND ia2t.c_topic_id = topic.id AND status = 'active'";
					$query .= "ORDER BY `order` ASC";
			
					$result3 = DBManager::exeQuery($query); 
					if (mysql_num_rows($result3) != 0) 
					{
						$manual=true;
						while ($row_man = mysql_fetch_array($result3)) 
						{	
							$url = "?mt=".$row_man['id'];
							$temp_array[$row_man ['id']] = array(
														'id' => $row_man['id'],
														'url' => $url, 
														'label'   => $row_man['label'],
													         );
						}
					}
				}		
			}	
		}
		if (!isset($all) && !isset($manual) && !isset($parametric)) 
			$this->displayError ($smarty);
		
		$this->multipleTopics = array_merge($this->multipleTopics, $temp_array);
	}
			

	public function get_introductory_act_id()
	{
		return $this->ia_c_DB['s_introductory_act_id'];
	}
	
	public function get_orientation_back_label()
	{
		$query = "SELECT * ";
		$query .= "FROM _TABLEPREFIX_c_introductory_act "; 
		$query .= "WHERE id = '".$this->ia_c_DB['id']."' ";
		$result = DBManager::exeQuery($query); 
		$row_ia = mysql_fetch_array($result);
		return $row_ia['orientation_back_label'];
	}
	
	public function getName() 
	{
		return $this->ia_c_DB['label'];
		
	}	
	
	public function getIntroductoryText()
	{
		return $this->ia_c_DB['introductory_text'];
		
	}
	
		public function getIntroductoryLinks()
	{
		return $this->multipleTopics;
	}

	public function getIAVectorMT()
	{
		return $this->multipleTopics;
	}

	
	public function getTypeIntroductoryAct()
	{
		return $this->typeIntroductoryAct;
	}
	
	
	public function getNavigationPattern()
	{
		return $this->ia_s_DB['navigation_pattern'];
	}
	
}



?>