<?php
#
# IDM-OS v 0.1
#

// checks for configuration file, if none found loads installation page
if (!file_exists( 'configuration.php' ) || filesize( 'configuration.php' ) < 10) 
{
	$self = rtrim( dirname( $_SERVER['PHP_SELF'] ), '/\\' ) . '/';
	header("Location: http://" . $_SERVER['HTTP_HOST'] . $self . "installation/index.php" );
	exit();
}

require_once ( 'configuration.php' );
require_once ( 'core/aural.php' );
require_once ( 'core/session.php' );
require_once ( 'core/idm.php' );
require_once ('core/error.php');
require_once ('smarty/setup.php');

// check if site is offline, if not, go on, otherwise redirect to offline page
if ($site_offline) 
{
	$self = rtrim( dirname( $_SERVER['PHP_SELF'] ), '/\\' ) . '/';
	header("Location: http://" . $_SERVER['HTTP_HOST'] . $self . "offline.php" );
	exit();
}


//Start session
$sessionObj = new sessionManager();
	
//create a smarty object
$smarty = new smarty_templates($sessionObj);

//set the variable containing the information of the site ( site name, meta... )	
$smarty->setSite();

//get the language information and create a variable 
$lang=array();
$lang=$smarty->getSitelanguages();
$smarty->assign('site_languages',$lang);

//$sessionObj->setSiteLanguage($site_default_language);
$language = $sessionObj->getSiteLanguage();
//get the aural structure information
$change_structure_url = $smarty->getAuralStructureURL();
$smarty->assign('aural_url',$change_structure_url);

//Get the id of the single topic related to the home page
$home=false;
$home_id=0;
$sessionObj->setHomePage_id($home_id);
$query =  "SELECT id ";
$query .= "FROM _TABLEPREFIX_s_topic ";
$query .= "WHERE is_home = 'true'";
$result = DBManager::exeQuery($query); //static method
$row = mysql_fetch_array($result);
if(mysql_affected_rows()!=0)
{
	$home=true;
	$home_id = $row['id'];
	$sessionObj->setHomePage_id($home_id);

}

else
{
	$err_msg ="The home page is not set.<br/> Please check your home page from the administrator area";
	error::display_error_message($smarty, $err_msg);
}


//get the element of the menu of the current language ($menu_name =nav1, nav2,...)

$menu_names=Navigator::getMenuNames($language);
	

$smarty->assign('menu_names',$menu_names);
$menu_nav=array();
//create an array containing all the information of all menu.
//every element of the menu are accessible using the key of the menu (nav1, nav2....) 
foreach ($menu_names as $menu_name)
{
	$menu_nav[$menu_name]=Navigator::getMenu($menu_name, $language, $sessionObj);
}

// create the menu variable 
$smarty->assign('menu',$menu_nav);





//ta_vector_mt This vector contains the list of Multiple Topic belongs to the Transition Act
$ta_vector_mt = array ();


// Display a Dialogue Act (if called!)
if (isset($_REQUEST['da'])) 
{

	$home = false;
	// we ar not in home page
	$smarty->assign('home',false);
	
	// Initialize a new Dialogue Act
	if (isset ($_REQUEST['mt_id']))
		$da = new DialogueAct($_REQUEST['da'], $language, $_REQUEST['mt_id'], $smarty);
	else
		$da = new DialogueAct($_REQUEST['da'], $language, '', $smarty);
		
	//check if the access data structure is aural or visual
	if( $sessionObj->getVariable('aural') != NULL )
	{
		$auralDS = new AuralDataStructureDA($da, $smarty, $language, $sessionObj);
		$structure = $auralDS->createAuralPage();
		$smarty->assign('aural_structure',$structure);
		$template_file='aural.tpl';
		$smarty->display($template_file);
	}	
	
	else
	{
		//$topic_title =$da->getLabelMT();
		$content_title =$da->getLabelDA();
		$smarty->assign('da_title',$content_title);
	
		//get the structural links
		$structuralLinks = $da->getStructuralLinks();
		$smarty->assign('structuralLinks',$structuralLinks);
	
		// Get Transition Act Information
		$transitionActInfo = $da->getTransitionActInfo();
		$smarty->assign('transition_act_info',$transitionActInfo);
		
		// Get Transition Links
		$transitionLinks = $da->getTransitionLinks();
		$smarty->assign('transition_links',$transitionLinks);
	
		//Set a variable with the current topic id about the content. This variable is used to show the guided tour information 
		$current_mt= $da->get_c_topic_id();
		$smarty->assign('current_mt',$current_mt);

// render Global Items
		$st = $da->getST($language, $smarty);
		$globalItem = $st->renderGlobalItems($smarty, $_REQUEST['mt_id'], $language);
		$smarty->assign('globalItem',$globalItem);
	
		// render output text (Content of DA)
		$content = $da->renderItems($smarty);
	
		//output content of the dialogue act
		$smarty->assign('content',$content);
		
		//get the information about the file used to display the contents
		$type="da";
		$s_id = $da->get_topic_id();
		if(!$template_file = $smarty->get_template_file($smarty, $type, $s_id))
			$template_file='da.tpl';
		// call template for visualization
		$smarty->display($template_file);
	}
}

// Display a Transition Act (if called!)
if (isset($_REQUEST['ta'])) {
	
	// delete the session variable active_ia and ia_vector_mt
	$sessionObj->deleteVariable('active_ia');
	$sessionObj->deleteVariable('ia_vector_mt');

	

	// we ar not in home page
	$home = false;
	$smarty->assign('home',false);
	
	// Initialize a new Transition Act, with some parameters:
	$ta = new TransitionAct($_REQUEST['ta'],$language, $_REQUEST['mt_id'], $smarty);
	
	//check if the access data structure is aural or visual
	if( $sessionObj->getVariable('aural') != NULL )
	{
		$auralDS = new AuralDataStructureTA($ta, $smarty, $language, $sessionObj);
		$structure = $auralDS->createAuralPage();
		$smarty->assign('aural_structure',$structure);
		$template_file='aural.tpl';
		$smarty->display($template_file);
	}
	
	else
	{	
		//get the information about the title of the transition act
		$ta_title = $ta->getName();
		$smarty->assign('ta_title',$ta_title);
		
		// get the information about the introduction of the introductory act
		$ta_introduction = $ta->getIntroductoryText();
		$smarty->assign('ta_introduction',$ta_introduction);
		
		// build the links of the introductory act
		$ta_links = $ta->getTransitionLinks();
		$smarty->assign('ta_links',$ta_links);
	
		//get the information about the file used to display the contents
		$s_id = $ta->get_transition_act_id();
		$type="ta";
		if(!$template_file = $smarty->get_template_file($smarty, $type, $s_id))
			$template_file='ta.tpl';
		// call template for visualization
		$smarty->display($template_file);
	}
}

if (isset($_REQUEST['mt'])) 
{
	
	if (isset($_REQUEST['direct']))
	{
	// delete the session variable active_ia and ia_vector_mt
	$sessionObj->deleteVariable('active_ia');
	$sessionObj->deleteVariable('ia_vector_mt');

	}
	
	// we ar not in home page
	$home = false;
	
	$smarty->assign('home',false);

	// Initialize a new MT
	$mt = new MultipleTopic($_REQUEST['mt'], $smarty);
	
	// Get default Dialogue Act id
	$da = $mt->getDefaultDA($language, $smarty);
	$mt_id= $da->getMTopicId();
	
	//Set a variable with the current topic id about the content. This variable is used to show the guided tour information 
	$current_mt= $da->get_c_topic_id();
	$smarty->assign('current_mt',$current_mt);

	
	//check if the access data structure is aural or visual
	if( $sessionObj->getVariable('aural') != NULL )
	{
		$auralDS = new AuralDataStructureDA($da, $smarty, $language, $sessionObj);
		$structure = $auralDS->createAuralPage();
		$smarty->assign('aural_structure',$structure);
		$template_file='aural.tpl';
		$smarty->display($template_file);
	}
	
	else
	{
		$content_title =$da->getLabelDA();
		$smarty->assign('da_title',$content_title);
	
		//get the structural links
		$structuralLinks = $da->getStructuralLinks();
		$smarty->assign('structuralLinks',$structuralLinks);
	
		// Get Transition Act Information
		$transitionActInfo = $da->getTransitionActInfo();
		$smarty->assign('transition_act_info',$transitionActInfo);
		// Get Transition Links
		$transitionLinks = $da->getTransitionLinks();
		$smarty->assign('transition_links',$transitionLinks);
		// render output text (Content of DA)
		$content = $da->renderItems($smarty);
	
		// render Global Items
		$st = $da->getST($language, $smarty);
		$globalItem = $st->renderGlobalItems($smarty, $mt_id, $language);
		$smarty->assign('globalItem',$globalItem);
		
		//output content of the dialogue act
		$smarty->assign('content',$content);
		//get the information about the file used to display the contents
		$type="da";
		$s_id = $da->get_topic_id();
		if(!$template_file = $smarty->get_template_file($smarty, $type, $s_id))
			$template_file='da.tpl';
		// call template for visualization
		$smarty->display($template_file);
	}
	
}

if (isset($_REQUEST['ia'])) 
{
	
	$home = false;
	
	$smarty->assign('home',false);

	// Initialize a new ia
	$ia = new IntroductoryAct($_REQUEST['ia'], $language, $smarty);
	
	//check if the access data structure is aural or visual
	if( $sessionObj->getVariable('aural') != NULL )
	{
		$auralDS = new AuralDataStructureIA($ia, $smarty, $language, $sessionObj);
		$structure = $auralDS->createAuralPage();
		$smarty->assign('aural_structure',$structure);
		$template_file='aural.tpl';
		$smarty->display($template_file);
	}
	
	else
	{
		//get the information about the title of the introductory act
		$ia_title = $ia->getName();
		$smarty->assign('ia_title',$ia_title);
		
		// get the information about the introduction of the introductory act
		$ia_introduction = $ia->getIntroductoryText();
		$smarty->assign('ia_introduction',$ia_introduction);
		
		//get the information related to the type of the introductory act 
		//(single or parametric)
		$typeIntroductoryAct = $ia->getTypeIntroductoryAct();
		$smarty->assign('typeIntroductoryAct',$typeIntroductoryAct);
		// build the links of the introductory act
		$ia_links = $ia->getIntroductoryLinks();
		$smarty->assign('ia_links',$ia_links);
		
		// Set the session variable 'active_ia' with the current Introductory Act
		$sessionObj->setVariable($_REQUEST['ia'], 'active_ia');
		//get the orientation back label
		$orientation_label= $ia->get_orientation_back_label();
		$sessionObj->setVariable($orientation_label, 'orientation_label');
		//get the information about the navigation pattern used for the element of the current Introductory Act
		$ia_navigation_pattern =  $ia->getNavigationPattern();
		$sessionObj->setVariable($ia_navigation_pattern, 'ia_navigation_pattern');
		//Set the session array 'ia_vector_mt' to contain the list of Multiple Topic belongs to the active Introductory Act
		$ia_vector_mt = $ia->getIAVectorMT();
		$sessionObj->setVariable($ia_vector_mt, 'ia_vector_mt');
		
		
		//get the information about the file used to display the contents
		$type="ia";
		$s_id = $ia->get_introductory_act_id();
		if(!$template_file = $smarty->get_template_file($smarty, $type, $s_id))
			$template_file='ia.tpl';
		// call template for visualization
		$smarty->display($template_file);
	}
}


// Handle Single Topic call
if (isset($_REQUEST['st'])) 
{
	// delete the session variable active_ia and ia_vector_mt
	$sessionObj->deleteVariable('active_ia');
	$sessionObj->deleteVariable('ia_vector_mt');

	
	//check if the single topic corresponding to the home page 
	if ($_REQUEST['st'] == $home_id)
		$home=true;
	else
	{	
		$home = false;
		// we ar not in home page
		$smarty->assign('home',false);
		// Initialize a new ST
		$st = new SingleTopic($_REQUEST['st'],$language, $smarty);
		if ($st->get_topic_id() == $sessionObj->getHomePage_id())
		{
			$smarty->assign('home',true);
		}
		// Get default Dialogue Act id
		$da = $st->getDefaultDA($language, $smarty);
		
		//check if the access data structure is aural or visual
		if( $sessionObj->getVariable('aural') != NULL )
		{
			$auralDS = new AuralDataStructureDA($da, $smarty, $language, $sessionObj);
			$structure = $auralDS->createAuralPage();
			$smarty->assign('aural_structure',$structure);
			$template_file='aural.tpl';
			$smarty->display($template_file);
		}
		
		else
		{
			$content_title =$da->getLabelDA();
			$smarty->assign('da_title',$content_title);
		
			//get the structural links
			$structuralLinks = $da->getStructuralLinks();
			$smarty->assign('structuralLinks',$structuralLinks);
		
			// render output text (Content of DA)
			$content = $da->renderItems($smarty);
		
			// render global item (Common content of the topic)
			$globalItem = $st->renderGlobalItems($smarty, '', $language);
			$smarty->assign('globalItem',$globalItem);
		
			//output content of the dialogue act
			$smarty->assign('content',$content);
			//get the information about the file used to display the contents
			$type="da";
			$s_id = $st->get_topic_id();
			if(!$template_file = $smarty->get_template_file($smarty, $type, $s_id))
				$template_file='da.tpl';
			// call template for visualization
			$smarty->display($template_file);
		}
	}
}


//if home page is requested, then prepare home page..

if ($home) 
{
	// delete the session variable active_ia and ia_vector_mt
	$sessionObj->deleteVariable('active_ia');
	$sessionObj->deleteVariable('ia_vector_mt');


	// Initialize a new ST
	$st = new SingleTopic( $home_id, $language, $smarty);
	//get the id of the current topic (home page)
	
	$s_topic_id = $st->get_topic_id();

	// Get default Dialogue Act id
	$da = $st->getDefaultDA($language, $smarty);
	
	//check if the access data structure is aural or visual
	if( $sessionObj->getVariable('aural') != NULL )
	{
		$auralDS = new AuralDataStructureDA($da, $smarty, $language, $sessionObj);
		$structure = $auralDS->createAuralPage();
		$smarty->assign('aural_structure',$structure);
		$template_file='aural.tpl';
		$smarty->display($template_file);
	}
	
	else
	{
		$content_title =$da->getLabelDA();
		$smarty->assign('da_title',$content_title);
	
		//get the structural links
		$structuralLinks = $da->getStructuralLinks();
		$smarty->assign('structuralLinks',$structuralLinks);
	
		// render output (Content of DA)
		$content = $da->renderItems($smarty);
		
		// render global item (Common content of the topic)
		$globalItem = $st->renderGlobalItems($smarty, '', $language);
		$smarty->assign('globalItem',$globalItem);
	
		// create a variable used for the rendering of the home page
		$smarty->assign('home',true);
		
		//output content of the dialogue act
		$smarty->assign('content',$content);
		
		//get the information about the file used to display the contents
		$type="da";
		if(!$template_file = $smarty->get_template_file($smarty, $type, $s_topic_id))
			$template_file='index.tpl';
		
		// call template for visualization
		$smarty->display($template_file);
	}
} 




?>