<?php


if (!file_exists('../configuration_sample.php'))
	die('Sorry, I need a configuration_sample.php file to work from. Please re-upload this file.');

if (!is_writable('../')) die("Sorry, I can't write to the directory. You'll have to either change the permissions on your IDM-OS directory or create your configuration.php manually.");

require('../core/file.php');

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;
	
header( 'Content-Type: text/html; charset=utf-8' );
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>

<title>
IDM-OS: Configuration
</title>

<!-- Meta Tags -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="robots" content="index, follow" />
<link rel="icon" href="../favicon.ico" type="image/x-icon" />
<link rel="stylesheet" type="text/css" media="screen" href="../styles/style_installation.css" />
<script type="text/javascript" src="../js/mootools.v1.11.js"></script>
<script type="text/javascript" src="../js/installation.js"></script>

</head>

<body>	
<div id="container">

<div id="top">&nbsp;</div>

<div class="info">
<h2>Configuration</h2>
<p>
	Please fill all the fields for the configuration of IDM-OS.
	<br/>
	The installation process is available only in english.
</p>
</div>

<?php

// Check if configuration.php already exist
if (file_exists('../configuration.php'))
	//Error message
	die("<p>The file 'configuration.php' already exists. If you need to reset any of the configuration items in this file, please delete it first. You may try <a href='index.php'>installing now</a>.</p></body></html>");

switch($step) {
	case 0:
?>	

<form id="form" class="wufoo" method="post" action="index.php?step=2" enctype="multipart/form-data">

	<ul id="formFields">

		<li>
			<p class="instruct">Insert the name of the database</p>
			<label class="desc" for="dbName">DB name</label>
			<div>
				<input id="dbName" name="dbName" class="field text large" type="text" maxlength="255" value=""/> 
			</div>
		</li>

		<li>
			<p class="instruct">Insert your MySQL username</p>
			<label class="desc" for="dbUserName">DB username</label>
			<div>
				<input id="dbUserName" name="dbUserName" class="field text large" type="text" maxlength="255" value=""/> 
			</div>
		</li>

		<li>
			<p class="instruct">Insert your MySQL password</p>
			<label class="desc" for="dbPassword">DB password</label>
			<div>
				<input id="dbPassword" name="dbPassword" class="field text large" type="password" maxlength="255" value=""/> 
			</div>
		</li>

		<li>
			<p class="instruct">Insert your MySQL host address</p>
			<label class="desc" for="dbHost">DB host</label>
			<div>
				<input id="dbHost" name="dbHost" class="field text large" type="text" maxlength="255" value="localhost"/> 
			</div>
		</li>

		<li>
			<p class="instruct">Insert table prefix</p>
			<label class="desc" for="dbPrefix">Table prefix</label>
			<div>
				<input id="dbPrefix" name="dbPrefix" class="field text medium" type="text" maxlength="255" value="idm_"/> 
			</div>
		</li>

	</ul>

	<div class="buttons">
		<input id="submit" name="submit" class="button" type="submit" value="Submit" />
	</div>

</form>



<?php
	break;
	
	//Second step of the installation
	case 2:
	
	$dbName  = trim($_POST['dbName']);
	$dbUserName   = trim($_POST['dbUserName']);
	$dbPassword = trim($_POST['dbPassword']);
	$dbHost  = trim($_POST['dbHost']);
	$dbPrefix  = trim($_POST['dbPrefix']);
	
	if (empty($dbPrefix)) $dbPrefix = 'idm_';
	
	//Check if the DB data are correct
	require("../core/db.php");
	if (!DBManager::checkDB($dbHost,$dbName,$dbUserName,$dbPassword)) {
		//Error message
		die("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error establishing a database connection!</h3><p><a href=\"index.php\">Please reinsert the data</a></p></div><div id=\"footer\"><p>IDM-OS | Form created with the support of <a href=\"http://wufoo.com\" title=\"Wufoo\">Wufoo</a></p></div></div></body></html>");
	}
	
	
	fileSystemManager::copyAndRenameFile('../configuration_sample.php','configuration.php');
	
	// Writing data in configuration.php
	//////////////////////////////////
	// Setting array (see the definition of fileSystemManager::subStrInFile)
	
	$arrayLineString = array("\$db_user = 'NOT_", "\$db_password = '", "\$db_host = 'NOT_", "\$db_name = 'NOT_", "\$db_prefix = 'NO");
	$arrayOldString = array("NOT_SET", "NOT_SET", "NOT_SET", "NOT_SET", "NOT_SET");
	$arrayNewString = array($dbUserName, $dbPassword, $dbHost, $dbName, $dbPrefix);
	
	fileSystemManager::subStrInFile('../configuration.php',$arrayOldString, $arrayNewString, $arrayLineString);
	
	?>
	
	<div class="okMsg">
		<h3><img src="images/ok.gif" alt="Ok"/> Connection with MySQL database established!</h3>
	</div>
	
	<form id="form" class="wufoo" method="post" action="setup.php" enctype="multipart/form-data">

		<ul id="formFields">

			<li>
				<p class="instruct">Insert the title of the website</p>
				<label class="desc" for="siteName">Site name</label>
				<div>
					<input id="siteName" name="siteName" class="field text large" type="text" maxlength="255" value=""/> 
				</div>
			</li>
			
			<li>
				<p class="instruct">If no, we provide an example<br/>The default language is english</p>
				<label class="desc" for="sample">Do you have an .xml file with the IDM structure?</label>
				<div>
					<select class="field select small "id="sample" name="sample"> 
						<option value="1">Yes</option>
						<option value="0" selected>No</option>
					</select>
				</div>
			</li>
			
			<li id="optional" class="hidden">
				<p class="instruct">Choose the IDM XML file</p>
				<label class="desc" for="XMLFile">IDM XML</label>
				<div>
					<input id="XMLFile" name="XMLFile" class="field file large" type="file" maxlength="255" value=""/> 
				</div>
			
				<p class="instruct">Select the default language<br/>(the same of the IDM file)</p>
				<label class="desc" for="language">Default Language</label>
				<div>
					<select class="field select medium "id="language" name="language"> 
						<option value="1">English</option>
						<option value="2">Italian</option>
						<option value="3">French</option>
					</select>
				</div>
			</li>
		
		</ul>

		<div class="buttons">
			<input id="submit" name="submit" class="button" type="submit" value="Submit" />
		</div>
	</form>
<?php	
	break;
	
	default:
		break;
}
?>
	<div id="footer">
		<p>IDM-OS | Form created with the support of <a href="http://wufoo.com" title="Wufoo">Wufoo</a></p>
	</div>
</div><!--container-->
</body>
</html>
