<?php
require('../configuration.php');
require('../core/db.php');
require('../core/validation.php');

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;

header( 'Content-Type: text/html; charset=utf-8' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>

<title>
IDM-OS: Configuration
</title>

<!-- Meta Tags -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="robots" content="index, follow" />
<link rel="icon" href="../favicon.ico" type="image/x-icon" />
<link rel="stylesheet" type="text/css" media="screen" href="../styles/style_installation.css" />
</head>

<body>	
<div id="container">

<div id="top">&nbsp;</div>

<div class="info">
<h2>Configuration</h2>
<p>
	Please fill all the fields for the configuration of IDM-OS.
	<br/>
	The installation process is available only in english.
</p>
</div>
<?php
switch($step) {
	case 0:
?>
<form id="form" class="wufoo" method="post" action="set_user.php?step=2" enctype="multipart/form-data">

	<ul id="formFields">

		<li>
			<p class="instruct">Insert your name</p>
			<label class="desc" for="name">Name</label>
			<div>
				<input id="name" name="name" class="field text large" type="text" maxlength="255" value="<?if (isset($_GET['name'])) echo $_GET['name']?>"/> 
			</div>
		</li>
		
		<li>
			<p class="instruct">Insert your username</p>
			<label class="desc" for="user">Username</label>
			<div>
				<input id="user" name="user" class="field text large" type="text" maxlength="255" value="<?if (isset($_GET['user'])) echo $_GET['user']?>"/> 
			</div>
		</li>

		<li>
			<p class="instruct">Insert your password</p>
			<label class="desc" for="password">Password</label>
			<div>
				<input id="password" name="password" class="field text large" type="password" maxlength="255" value=""/> 
			</div>
		</li>
		
		<li>
			<p class="instruct">Re-insert your password</p>
			<label class="desc" for="rePassword">Confirm password</label>
			<div>
				<input id="rePassword" name="rePassword" class="field text large" type="password" maxlength="255" value=""/> 
			</div>
		</li>

		<li>
			<p class="instruct">Enter your e-mail</p>
			<label class="desc" for="mail">E-mail</label>
			<div>
				<input id="mail" name="mail" class="field text large" type="text" maxlength="255" value="<?if (isset($_GET['mail'])) echo $_GET['mail']?>"/> 
			</div>
		</li>

	</ul>

	<div class="buttons">
		<input id="submit" name="submit" class="button" type="submit" value="Submit" />
	</div>

</form>
<?php
	break;
	
	case 2:
		//Checking data
		
		$error = 0;
		
		if (!valid::hasValue($_POST['name']))
		{
			$error++;
			echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The name field is empty!</h3></div>");
		}
		else
			if (!valid::isAlphaNumeric($_POST['name']))
			{
				$error++;
				echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The name must be alphanumeric!</h3></div>");
			}
		
		
		if (!valid::hasValue($_POST['user']))
		{
			$error++;
			echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The username field is empty!</h3></div>");
		}
		else	
			if (!valid::isAlphaNumeric($_POST['user']))
			{
				$error++;
				echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The username must be alphanumeric!</h3></div>");
			}
		
		if (!valid::hasValue($_POST['password']))
		{
			$error++;
			echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The password field is empty!</h3></div>");
		}
		else
			if (!valid::compare($_POST['password'],$_POST['rePassword'], true))
			{
				$error++;
				echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Passwords are different!</h3></div>");
			}
		
		
		if (!valid::hasValue($_POST['mail']))
		{
			$error++;
			echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The e-mail field is empty</h3></div>");
		}
		else
			if (!valid::isEmail($_POST['mail']))
			{
				$error++;
				echo("<div class=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> The e-mail is not valid!</h3></div>");
			}
		
		if ($error == 0)
		{
			//Insert data into the DB
			$fields = array('id','name','username','password','group','email','status');
			$values = array('NULL',$_POST['name'],$_POST['user'],md5($_POST['password']),1,$_POST['mail'],'active');
			
			
			DBManager::insertQuery('_TABLEPREFIX_c_user',$fields,$values);
			
			echo("<div class=\"okMsg\" style=\"height: 75px\"><h3><img src=\"images/ok.gif\" alt=\"Ok\"/> Installation complete, congratulations!</h3><ul><li>Now for security reasons delete the folder <strong>/installation/</strong></li><li>Open the <a href=\"../administrator\" title=\"Administrator\">admin page</a> to manage the website</li></ul></div>");
		}
		else
		{
			//back to the previous page
			echo("<div class=\"info\"><h2 class=\"center\"><img src=\"images/user.gif\" alt=\"User\"/><a href=\"set_user.php?name=".$_POST['name']."&user=".$_POST['user']."&mail=".$_POST['mail']."\" title=\"New user\"> You must re-insert the data </a><img src=\"images/user.gif\" alt=\"User\"/></h2></div>");
		}

	break;
	
	default:
		break;
}
?>
	<div id="footer">
		<p>IDM-OS | Form created with the support of <a href="http://wufoo.com" title="Wufoo">Wufoo</a></p>
	</div>
</div><!--container-->
</body>
</html>