<?php
require('../configuration.php');
require('../core/file.php');
require('../core/db.php');
require('../core/xml.php');
require('../core/logger.php');

header( 'Content-Type: text/html; charset=utf-8' );
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>

<title>
IDM-OS: Configuration
</title>

<!-- Meta Tags -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="robots" content="index, follow" />
<link rel="icon" href="../favicon.ico" type="image/x-icon" />
<link rel="stylesheet" type="text/css" media="screen" href="../styles/style_installation.css" />
</head>

<body>
<div id="container">

<div id="top">&nbsp;</div>

<div class="info">
<h2>Configuration</h2>
<p>
	Please fill all the fields for the configuration of IDM-OS.
	<br/>
	The installation process is available only in english.
</p>
</div>
<?php

// Check if the users have an .xml file, otherwise use an example
if ($_POST['sample'] == 0){
	// Set the name of the .xml file
	$idm_file = "idm_example.xml";
}
else
{
	// Upload
	//////////////////////////
	//Verify type of the file
	if (!fileSystemManager::verifyGenericFileType("XMLFile","xml"))
	{
		//Error message
		echo("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error: the type of the file is incorrect!</h3><p><a href=\"index.php\">Please reinsert the data</a></p></div><div id=\"footer\"><p>IDM-OS | Form created with the support of <a href=\"http://wufoo.com\" title=\"Wufoo\">Wufoo</a></p></div></div></body></html>");
		unlink ("../configuration.php");
		die();
	}
	//Upload file .xml
	if (fileSystemManager::uploadFile($_FILES['XMLFile']['tmp_name'], '../core/idm_schema/' , $_FILES['XMLFile']['name']))
	{
		//Ok message
		echo("<div class=\"okMsg\"><h3><img src=\"images/ok.gif\" alt=\"Ok\"/> XML file uploaded!</h3></div>");
	}
	else
	{
		//Error Message
		echo("<div id=\"errorMsg\"><h3><img src=\"images/cancel.gif\" alt=\"Error\"/> Error during the upload of the file!</h3><p><a href=\"index.php\">Please reinsert the data</a></p></div><div id=\"footer\"><p>IDM-OS | Form created with the support of <a href=\"http://wufoo.com\" title=\"Wufoo\">Wufoo</a></p></div></div></body></html>");
		unlink ("../configuration.php");
		die();
	}
	// Set the name of the .xml file
	$idm_file = $_FILES['XMLFile']['name'];
}
///////////////////////////////

//Setting variable in the configuration.php file
////////////////////////////////////////////////
$arrayLineString = array("\$site_name = 'NO", "\$site_live_url =", "\$site_php_applic", "\$site_absolute_p", "\$idm_file_name =","\$site_default_la");
$arrayOldString = array("NOT_SET", "NOT_SET", "NOT_SET", "NOT_SET", "NOT_SET","NOT_SET");


$site_absolute_path = addslashes(substr(dirname(__FILE__),0,-12));
$site_php_application = substr($_SERVER['PHP_SELF'],0,-22);
$site_live_url = "http://".$_SERVER["SERVER_NAME"]."/";
$site_name = addslashes($_POST['siteName']);
$site_default_language = $_POST['language'];

$arrayNewString = array($site_name, $site_live_url, $site_php_application, $site_absolute_path, $idm_file, $site_default_language);

fileSystemManager::subStrInFile('../configuration.php',$arrayOldString, $arrayNewString, $arrayLineString);
//////////////////////////////////////////////////

// DB Operation
//////////////////////////////////
//Setting encoding of the database
$query = "ALTER DATABASE ";
$query .= $db_name." ";
$query .= "DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci";
DBManager::exeQuery($query);

//DB Operation depending on the .xml file
if ($_POST['sample'] == 0)
{
	// DB Operation
	////////////////////////////////////
	// Set right prefix
	fileSystemManager::copyAndRenameFile('sql/idmos_example.sql','idmos_example_with_prefix.sql');
	$arrayLineString = array("CREATE TABLE `_T","INSERT INTO `_TA");
	$arrayOldString = array("_TABLEPREFIX_","_TABLEPREFIX_");
	$arrayNewString = array($db_prefix,$db_prefix);
	fileSystemManager::subStrInFile('sql/idmos_example_with_prefix.sql',$arrayOldString, $arrayNewString, $arrayLineString);


	//Table creation
	DBManager::parseMysqlDump('sql/idmos_example_with_prefix.sql',$db_host,$db_name,$db_user,$db_password);
	unlink('sql/idmos_example_with_prefix.sql');
	//Ok message
	echo("<div class=\"okMsg\"><h3><img src=\"images/ok.gif\" alt=\"Ok\"/> Sample XML file activated!</h3></div>");
}
else
{
	// DB Operation
	////////////////////////////////////
	// Set right prefix
	fileSystemManager::copyAndRenameFile('sql/idmos_empty.sql','idmos_with_prefix.sql');
	$arrayLineString = array("CREATE TABLE `_T","INSERT INTO `_TA");
	$arrayOldString = array("_TABLEPREFIX_","_TABLEPREFIX_");
	$arrayNewString = array($db_prefix,$db_prefix);
	fileSystemManager::subStrInFile('sql/idmos_with_prefix.sql',$arrayOldString, $arrayNewString, $arrayLineString);

	//Table creation
	DBManager::parseMysqlDump('sql/idmos_with_prefix.sql',$db_host,$db_name,$db_user,$db_password);
	unlink('sql/idmos_with_prefix.sql');

	//Set active language in the BD
	$fields = array('status');
	$values = array('active');
	DBManager::updateQuery('_TABLEPREFIX_c_language',$fields,$values,"id = $site_default_language");
	
	//Ok message
	echo("<div class=\"okMsg\"><h3><img src=\"images/ok.gif\" alt=\"Ok\"/> Database structure created!</h3></div>");
	//////////////////////////////////
	// Parsing xml file
	/////////////////////////////////
	// Creating object

	$idmSchema = new XmlParser();

	//Insert Single Topic
	$table = '_TABLEPREFIX_s_topic';
	$fields = array('id','idm_name','topic_type','navigation_pattern');
	$values = array();
	foreach ($idmSchema->getSingleTopics() as $i =>$el)
	{
		//echo $el['id'];
		$values[$i][0] = 'NULL';
		$values[$i][1] = $el['id'];
		$values[$i][2] = 'st';
		$values[$i][3] = '';

	}
	DBManager::insertQuery($table,$fields,$values);

	//Insert Multiple Topic
	$table = '_TABLEPREFIX_s_topic';
	$fields = array('id','idm_name','topic_type','navigation_pattern');
	$values = array();
	foreach ($idmSchema->getMultipleTopics() as $i =>$el)
	{
		//echo $el['id'];
		$values[$i][0] = 'NULL';
		$values[$i][1] = $el['id'];
		$values[$i][2] = 'mt';
		$values[$i][3] = $el['navigationPattern'];

	}
	DBManager::insertQuery($table,$fields,$values);

	//Insert Dialogue Act
	$table = '_TABLEPREFIX_s_dialogue_act';
	$fields = array('id','idm_name','is_default','s_topic_id','order');
	$values = array();
	$order = 0;
	$prev_id = 0;
	foreach ($idmSchema->getDialogueActs() as $i =>$el)
	{

		$values[$i][0] = 'NULL';
		$values[$i][1] = $el['id'];
		if ($el['isDefault'] == '')
			$values[$i][2] = 'false';
		else
			$values[$i][2] = $el['isDefault'];
		$query = "SELECT id FROM _TABLEPREFIX_s_topic WHERE idm_name='".$el['topic_id']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][3] = $row[0];
		if ($prev_id != $row[0])
		{
			$prev_id = $row[0];
			$order = 1;
		}
		else
			$order ++;
		$values[$i][4] = $order;

	}
	DBManager::insertQuery($table,$fields,$values);

	//Insert Item
	$table = '_TABLEPREFIX_s_item';
	$fields = array('id','idm_name','item_type','s_dialogue_act_id','s_topic_id','multiple');
	$values = array();
	foreach ($idmSchema->getItems() as $i =>$el)
	{

		$values[$i][0] = 'NULL';
		$values[$i][1] = $el['id'];
		$values[$i][2] = $el['type'];
		if ($el['dialogue_act_id'] == '')
		{
			$query = "SELECT id FROM _TABLEPREFIX_s_topic WHERE idm_name='".$el['topic_id']."'";
			$result = DBManager::exeQuery($query);
			$row = mysql_fetch_row($result);
			$values[$i][3] = '';
			$values[$i][4] = $row[0];
			$values[$i][5] = $el['multiple'];
		}
		else
		{
			$query = "SELECT id FROM _TABLEPREFIX_s_dialogue_act WHERE idm_name='".$el['dialogue_act_id']."'";
			$result = DBManager::exeQuery($query);
			$row = mysql_fetch_row($result);
			$values[$i][3] = $row[0];
			$values[$i][4] = '';
			$values[$i][5] = '';
		}
	}
	DBManager::insertQuery($table,$fields,$values);

	//Insert Transition Act
	$table = '_TABLEPREFIX_s_transition_act';
	$fields = array('id','idm_name','from_s_topic_id','to_s_topic_id','from_cardinality','to_cardinality','has_introduction','mode','navigation_pattern');
	$values = array();
	$i = -1;
	
	foreach ($idmSchema->getTransitionActs() as $i =>$el)
	{

		$values[$i][0] = 'NULL';
		$values[$i][1] = $el['id'];
		$query = "SELECT id FROM _TABLEPREFIX_s_topic WHERE idm_name='".$el['fromMT']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][2] = $row[0];
		$query = "SELECT id FROM _TABLEPREFIX_s_topic WHERE idm_name='".$el['toMT']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][3] = $row[0];
		$values[$i][4] = $el['fromCardinality'];
		$values[$i][5] = $el['toCardinality'];
		$values[$i][6] = $el['hasIntroduction'];
		$values[$i][7] = $el['mode'];
		$values[$i][8] = $el['navigationPattern'];

	}
	
	if ($i != -1)
		DBManager::insertQuery($table,$fields,$values);

	//Insert Introductory Act
	$table = '_TABLEPREFIX_s_introductory_act';
	$fields = array('id','idm_name','navigation_pattern','has_introduction');
	$values = array();
	$i = -1;
	
	foreach ($idmSchema->getIntroductoryActs() as $i =>$el)
	{
		//echo $el['id'];
		$values[$i][0] = 'NULL';
		$values[$i][1] = $el['id'];
		$values[$i][2] = $el['navigationPattern'];
		$values[$i][3] = $el['hasIntroduction'];
	}
	
	if ($i != -1)
		DBManager::insertQuery($table,$fields,$values);

	//Insert Introductory Act reference
	$table = '_TABLEPREFIX_s_introductory_act2topic';
	$fields = array('id','s_introductory_act_id','s_topic_id','population_type');
	$values = array();
	$i = -1;
	
	foreach ($idmSchema->getIntroductoryActsReferenceTopic() as $i =>$el)
	{
		$values[$i][0] = 'NULL';
		$query = "SELECT id FROM _TABLEPREFIX_s_introductory_act WHERE idm_name='".$el['introductory_act_id']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][1] = $row[0];
		$query = "SELECT id FROM _TABLEPREFIX_s_topic WHERE idm_name='".$el['topic_id']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][2] = $row[0];
		$values[$i][3] = $el['populationType'];

	}
	if ($i != -1)
		DBManager::insertQuery($table,$fields,$values);
	
	$fields = array('id','s_introductory_act_id','s_introductory_act_element_id','population_type');
	$values = array();
	$i = -1;
	
	foreach ($idmSchema->getIntroductoryActsReferenceIa() as $i =>$el)
	{
		$values[$i][0] = 'NULL';
		$query = "SELECT id FROM _TABLEPREFIX_s_introductory_act WHERE idm_name='".$el['introductory_act_id']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][1] = $row[0];
		$query = "SELECT id FROM _TABLEPREFIX_s_introductory_act WHERE idm_name='".$el['ia_id']."'";
		$result = DBManager::exeQuery($query);
		$row = mysql_fetch_row($result);
		$values[$i][2] = $row[0];
		$values[$i][3] = $el['populationType'];

	}
	if ($i != -1)
		DBManager::insertQuery($table,$fields,$values);
}

//Ok message
echo("<div class=\"okMsg\"><h3><img src=\"images/ok.gif\" alt=\"Ok\"/> Parsing XML and populating DB.</h3></div>");
//////////////////////////////////
?>
<div class="info">
	<h2 class="center"><img src="images/user.gif" alt="User"/><a href="set_user.php" title="New user"> Now you must create a new user </a><img src="images/user.gif" alt="User"/></h2>
</div>
	<div id="footer">
		<p>IDM-OS | Form created with the support of <a href="http://wufoo.com" title="Wufoo">Wufoo</a></p>
	</div>
</div><!--container-->
</body>
</html>
