// JavaScript Document
var EIP = new Class({
	
	initialize: function(elements, url, options){
		this.options = Object.extend({
			observingAction: 'click',
			type: 'input',
			size: false,
			cols: 50,
			rows: false,
			empty: 'No text, edit..',
			ok: 'Save',
			cancel: 'Cancel',
			saving: 'Saving...',
			cssInput: 'EIP_input',
			cssTextarea: 'EIP_textarea',
			cssSelect: 'EIP_select',
			cssSubmit: 'EIP_select',
			cssCancel: 'EIP_cancel',
			cssSaving: 'EIP_saving',
			cssForm: 'EIP_form',
			tip: 'toolTip',
			refresh: false,
			options: false
		}, options || {});
		
		this.url = url; //Ajax url
		$each(elements, function(el){
			this.el = $(el);
			if (this.el.getProperty('id') == '')
				this.el.setProperty('id',$random(1,100000));
			if (this.el.innerHTML == '')
				this.el.innerHTML = this.options.empty;
			this.el.addEvent('click', function(event){
				this.edit(el);
			}.bindWithEvent(this));
		}, this);
	},

	edit: function(el) {
		try{
			eval(this.options.tip).hide();
		}catch(e){};
		el.setStyle('display','none');
		var form = new Element('div');
		form.innerHTML = this.generateForm(el);
		form.setProperty('id','eip_editor');
		form.injectBefore(el);
		$(el.getProperty('id') + '_value').focus();
		this.formEventsSetting(el,form);
	},

	generateForm: function(el) {
		var html = '<form id="' + el.id + '_eip" class = "' + this.options.cssForm + '" style = "display:inline;">';
		if (el.innerHTML == this.options.empty)
			var value = '';
		else
			var value = el.innerHTML;
		
		switch(this.options.type) {
			case "input": 
				var size = this.options.size || (el.innerHTML.length + 10 > 100 ? 100 : (el.innerHTML.length + 10));		
				html +=  '<input name="value" class = "' + this.options.cssInput + '" id="' + el.getProperty('id') + '_value" value = "' + value + '" size = "' + size + '" />';
			break;
			case "textarea":
				var cols = this.options.cols || 50;
				var rows = this.options.rows || el.innerHTML.length / cols + 3
				html +=  '<textarea name="value" class = "' + this.options.cssTextarea + '" id="' + this.id + '_value" cols = "' + cols + '" rows = "' + rows + '">' + value + '</textarea><br />';
			break;
			case "select":
				html +=  '<select name="value" class = "' + this.options.cssSelect + '" id="' + el.getProperty('id') + '_value">';
				var z = '';
				var options = this.options.options;
				for (o in options) {
					z = options[o];
					html += '<option id="eip_option_' + o + '" value = "' + o + '" ' + (z == el.innerHTML ? 'selected = "selected"' : '') + '>' + z + '</option>';
				}
				html +=  '</select>&nbsp;';
			break;
		}
		html += ' <input type="submit" id="' + el.getProperty('id') + '_submit" value = "' + this.options.ok + '" class = "' + this.options.cssSubmit + '"> <input type="button" id="' + el.getProperty('id') + '_cancel" value = "' + this.options.cancel + '" class = "' + this.options.cssCancel + '">';
		html += '</form>';
		return html;
	},

	formEventsSetting: function(el,form) {
		$(el.getProperty('id') + '_cancel').onclick = function() {
			el.setStyle('display','');
			form.remove();
		}.bind(this),
		$(el.getProperty('id') + '_submit').onclick = function() {
			var oldValue,option_name,value;
			switch(this.options.type) {
				case "input":
					value = $(el.getProperty('id') + '_value').value;
					if (el.innerHTML == this.options.empty)
						oldValue = '';
					else
						oldValue = el.innerHTML;
					var params = 'id=' + el.getProperty('id') + '&content=' + value + '&contentOld=' + oldValue;
					//alert (params);
					break;
				case "select":
					value = $(el.getProperty('id') + '_value').value;
					var z ='';
					var options = this.options.options;
					for (o in options) {
						z = options[o];
						if (z == el.innerHTML) oldValue = o;
					}
					option_name=this.options.type == 'select' ? '&option_name=' + $('eip_option_' + value).innerHTML : '';
					var params = 'id=' + el.getProperty('id') + '&content=' + value + option_name + '&contentOld=' + oldValue;
					value = $('eip_option_' + value).innerHTML;
					//alert(params);
					break;
			}
			el.setStyle('display','');
			form.remove();
			el.innerHTML = '<span class = "' + this.cssSaving + '">' + this.options.saving + '</span>';
			//alert(params);
			//new Ajax (this.url, {method: 'post',data: params, onComplete: this.saveChanges(el,value)}).request();
			new Ajax (this.url, {method: 'post',data: params, evalScripts: true}).request();
			el.innerHTML = value;
			//el.innerHTML = value || this.options.empty;
			el.innerHTML = value || oldValue;
			if (this.options.refresh==true)
			{
				//var ss = window.location.href.substr(0,51);
				//alert(ss);
				if (window.location.href.lastIndexOf('#') == -1)
					setTimeout("window.location.replace(window.location.href)",1000);
				else
				{
					n = window.location.href.lastIndexOf('#');
					address = window.location.href.substr(0,n);
					setTimeout("window.location.replace(address)",1000);
				}
			}
			
			
			return false;
		}.bind(this),
		$(el.getProperty('id') + '_eip').onsubmit = $(el.getProperty('id') + '_submit').onclick;
		
	}
});

EIP.implement(new Events);
EIP.implement(new Options);