/*
 * Smoothbox by Boris Popoff (http://gueschla.com)
 *
 * Based on Cody Lindley's Thickbox, MIT License
 *
 * Licensed under the MIT License:
 *   http://www.opensource.org/licenses/mit-license.php
 */

// on page load call TB_init
window.addEvent('domready', TB_init_form);

// prevent javascript error before the content has loaded
TB_WIDTH = 0;
TB_HEIGHT = 0;

// add smoothbox to href elements that have a class of .smoothbox
function TB_init_form(){
	$$('form#single_topic_add').each(function(el){$('submit_st').onclick=TB_bind_form});
	$$('form#multiple_topic_add').each(function(el){$('submit_mt').onclick=TB_bind_form});
	$$('form#introductory_act_add').each(function(el){$('submit_ia').onclick=TB_bind_form});
	$$('form#introductory_act_add_parametric').each(function(el){$('submit_ia_parametric').onclick=TB_bind_form});
	$$('form#transition_act_add').each(function(el){$('submit_ta').onclick=TB_bind_form});
}

function TB_bind_form(event) {
	var event = new Event(event);
	// stop default behaviour
	event.preventDefault();
	// remove click border
	this.blur();
	// get caption: either title or name attribute
	var caption = this.title || this.name || "";
	// get rel attribute for image groups
	var group = this.rel || false;
	// display the box for the elements href
	if (this.name == 'submit_st')
		url = $('single_topic_add').action+'&id='+$E('select').value;
	else if (this.name == 'submit_mt')
		url = $('multiple_topic_add').action+'&id='+$('mt').value;
	else if (this.name == 'submit_ia')
		url = $('introductory_act_add').action+'&id='+$('ia').value;
	else if (this.name == 'submit_ia_parametric')
		url = $('introductory_act_add_parametric').action+'&id='+$('ia_parametric').value;
	else if (this.name == 'submit_ta')
		url = $('transition_act_add').action+'&id='+$('ta').value;
	else
		return false;
	TB_show_form(caption, url, group);
	this.onclick=TB_bind_form;
	return false;
}


// called when the user clicks on a smoothbox link
function TB_show_form(caption, url, rel) {
	// create iframe, overlay and box if non-existent
	caption = 'IDM-OS';
	
	if ( !$("TB_overlay") )
	{
		new Element('iframe').setProperty('id', 'TB_HideSelect').injectInside(document.body);
		new Element('div').setProperty('id', 'TB_overlay').injectInside(document.body);
		TB_overlaySize_form();
		new Element('div').setProperty('id', 'TB_load').injectInside(document.body);
		$('TB_load').innerHTML = "<img src='images/loading.gif' />";
		TB_load_position_form();
		new Fx.Style('TB_overlay', 'opacity',{duration: 400, transition: Fx.Transitions.sineInOut}).start(0,0.6);
	}
	
	if ( !$("TB_load") )
	{		
		new Element('div').setProperty('id', 'TB_load').injectInside(document.body);
		$('TB_load').innerHTML = "<img src='images/loading.gif' />";
		TB_load_position_form();
	}
	
	if ( !$("TB_window") )
	{
		new Element('div').setProperty('id', 'TB_window').injectInside(document.body);
	}
	
	$("TB_overlay").onclick=TB_remove_form;
	window.onscroll=TB_positionEffect_form;

		var queryString = url.match(/\?(.+)/)[1];
		var params = TB_parseQuery_form( queryString );
		
		TB_WIDTH = (params['width']*1) + 30;
		TB_HEIGHT = (params['height']*1) + 40;
		TB_CLOSE = (params['TB_close']);

		var ajaxContentW = TB_WIDTH - 30,
			ajaxContentH = TB_HEIGHT - 45;
		
		if(url.indexOf('TB_iframe') != -1){				
			urlNoQuery = url.split('TB_');		
			$("TB_window").innerHTML += "<div id='TB_title'><div id='TB_ajaxWindowTitle'>"+caption+"</div><div id='TB_closeAjaxWindow'><a href='#' id='TB_closeWindowButton' title='Close'>"+TB_CLOSE+"</a></div></div><iframe frameborder='0' hspace='0' src='"+urlNoQuery[0]+urlNoQuery[1]+urlNoQuery[2]+"' id='TB_iframeContent' name='TB_iframeContent' style='width:"+(ajaxContentW + 29)+"px;height:"+(ajaxContentH + 17)+"px;' onload='TB_showWindow()'> </iframe>";
		} else {
			$("TB_window").innerHTML += "<div id='TB_title'><div id='TB_ajaxWindowTitle'>"+caption+"</div><div id='TB_closeAjaxWindow'><a href='#' id='TB_closeWindowButton'>close</a></div></div><div id='TB_ajaxContent' style='width:"+ajaxContentW+"px;height:"+ajaxContentH+"px;'></div>";
		}
				
		$("TB_closeWindowButton").onclick = TB_remove_form;
		
			if(url.indexOf('TB_inline') != -1){	
				$("TB_ajaxContent").innerHTML = ($(params['inlineId']).innerHTML);
				TB_position_form();
				TB_showWindow_form();
			}else if(url.indexOf('TB_iframe') != -1){
				TB_position_form();
				if(frames['TB_iframeContent'] == undefined){//be nice to safari
					$(document).keyup( function(e){ var key = e.keyCode; if(key == 27){TB_remove_form()} });
					TB_showWindow_form();
				}
			}else{
				var handlerFunc = function(){
					TB_position_form();
					TB_showWindow_form();
				};
				var myRequest = new Ajax(url, {method: 'post',update: $("TB_ajaxContent"),onComplete: handlerFunc}).request();
			}
			
	window.onresize=function(){ TB_position_form(); TB_load_position_form(); TB_overlaySize_form();}  
	
	document.onkeyup = function(event){ 	
		var event = new Event(event);
		if(event.code == 27){ // close
			TB_remove_form();
		}	
	}
		
}

//helper functions below

function TB_showWindow_form(){
	//$("TB_load").remove();
	//$("TB_window").setStyles({display:"block",opacity:'0'});
	
	var myFX = new Fx.Style('TB_window', 'opacity',{duration: 250, transition: Fx.Transitions.sineInOut, onComplete:function(){if ($('TB_load')) { $('TB_load').remove();}} }).start(0,1);
}

function TB_remove_form() {
 	$("TB_overlay").onclick=null;
	document.onkeyup=null;
	document.onkeydown=null;
	
	if ($('TB_imageOff')) $("TB_imageOff").onclick=null;
	if ($('TB_closeWindowButton')) $("TB_closeWindowButton").onclick=null;
	if ( $('TB_prev') ) { $("TB_prev").onclick = null; }
	if ( $('TB_next') ) { $("TB_next").onclick = null; }

	new Fx.Style('TB_window', 'opacity',{duration: 250, transition: Fx.Transitions.sineInOut, onComplete:function(){$('TB_window').remove();} }).start(1,0);
	new Fx.Style('TB_overlay', 'opacity',{duration: 400, transition: Fx.Transitions.sineInOut, onComplete:function(){$('TB_overlay').remove();} }).start(0.6,0);

	window.onscroll=null;
	window.onresize=null;	
	
	$('TB_HideSelect').remove();
	TB_init();
	window.location.reload( false );
	//change("tab2");
	return false;
}

function TB_position_form() {
	$("TB_window").setStyles({width: TB_WIDTH+'px', 
				 left: (window.getScrollLeft() + (window.getWidth() - TB_WIDTH)/2)+'px',
				 top: (window.getScrollTop() + (window.getHeight() - TB_HEIGHT)/2)+'px'});
}

function TB_positionEffect_form() {
	new Fx.Styles('TB_window', {duration: 75, transition: Fx.Transitions.sineInOut}).start({
		'left':(window.getScrollLeft() + (window.getWidth() - TB_WIDTH)/2)+'px',
		'top':(window.getScrollTop() + (window.getHeight() - TB_HEIGHT)/2)+'px'});
}

function TB_overlaySize_form(){
	// we have to set this to 0px before so we can reduce the size / width of the overflow onresize 
	$("TB_overlay").setStyles({"height": '0px', "width": '0px'});
	$("TB_HideSelect").setStyles({"height": '0px', "width": '0px'});
	$("TB_overlay").setStyles({"height": window.getScrollHeight()+'px', "width": window.getScrollWidth()+'px'});
	$("TB_HideSelect").setStyles({"height": window.getScrollHeight()+'px',"width": window.getScrollWidth()+'px'});
}

function TB_load_position_form() {
	if ($("TB_load")) { $("TB_load").setStyles({left: (window.getScrollLeft() + (window.getWidth() - 56)/2)+'px', top: (window.getScrollTop() + ((window.getHeight()-20)/2))+'px',display:"block"}); }
}

function TB_parseQuery_form ( query ) {
	// return empty object
	if( !query )
		return {};
	var params = {};
	
	// parse query
	var pairs = query.split(/[;&]/);
	for ( var i = 0; i < pairs.length; i++ ) {
		var pair = pairs[i].split('=');
		if ( !pair || pair.length != 2 )
			continue;
		// unescape both key and value, replace "+" with spaces in value
		params[unescape(pair[0])] = unescape(pair[1]).replace(/\+/g, ' ');
   }
   return params;
}
