<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {load_aural_link} function plugin
 *
 * File:       function.load_aural_link.php<br>
 * Type:       function<br>
 * Name:       load_aural_link<br>
 * Date:       23.August.2007<br>
 * Purpose:    Prints out the hidden link for the aural acces data structure.<br>
 * Input:<br>
 *
 * No input parameters:<br>
 
 * Examples:
 * {load_aural_link}
 
 * @author     Alberto Terragni - Stefano Vaghi
 * @version    1.0
 */
 
function smarty_function_load_aural_link($param, &$smarty)
{
	$_output = '';
	
	$site_accessibility = $smarty->get_template_vars('site_accessibility');
	
	if( $site_accessibility == '1' )
	{
		$aural_url = $smarty->get_template_vars('aural_url');
	
		$_output = '
			<div style="position: absolute; top: -500px; left: -300px;">
				<a href="'.$aural_url.'?'.$_SERVER['QUERY_STRING'].'">Frase per accessibilita</a>
			</div>';
	}

    return $_output;
}
?>

