<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins 
 */


/**
 * Smarty {load_ia_links} function plugin
 *
 * File:       function.load.ia_links.php<br>
 * Type:       function<br>
 * Name:       load_ia_links<br>
 * Date:       21.May.2007<br>
 * Purpose:    Prints out all the links related to the introductory act<br>
 * Input:<br>
 * - a_style     			(optional) - string that indicates the style class of the 'a' 				                                         tag element related to each link
 
 * Examples:
 * {load_ia_links}
 

 * @author     Gabriele Perego - Stefano Sormani
 * @version    1.0
 */
	
function smarty_function_load_ia_links($param, &$smarty)
{
    $ia_links = $smarty->get_template_vars('ia_links');
    $typeIntroductoryAct = $smarty->get_template_vars('typeIntroductoryAct');
	$a_style =$param['a_style'];
	$_output = '';
	foreach ($ia_links as $ia_link)
	{
		$_output .='<a class="'.$a_style.'" href="'.$ia_link['url'].'"';
		$_output .='title="'.$ia_link['label'].'">'.$ia_link['label'].'</a><br />';
	}
	
    return $_output;
}
?>
