<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {load_menu} function plugin
 *
 * File:       function.load_menu.php<br>
 * Type:       function<br>
 * Name:       load_menu<br>
 * Date:       10.May.2007<br>
 * Purpose:    Prints out a menu item<br>
 * Input:<br>
 *   - menu       				(required) - string that indicates the menu   
 *   - ul_style                 (optional) - string that indicates the style class of the                                             'ul' tag element
 *   - current_element_style    (optional) - string that indicates the style class of the                                             'a' tag element

	
 * Examples:
 * {load_menu menu="nav1"}
 * {load_menu menu="nav1" ul_style="floatRight" current_element_style="here"}
 

 * @author     Gabriele Perego - Stefano Sormani
 * @version    1.0
 */

require_once ( 'core/session.php' );
 
function smarty_function_load_menu($params, &$smarty)
{
	$sessionObj = new sessionManager();
    $menu =$params['menu'];
    $ul_style= $params['ul_style'];
    $current_element_style= $params['current_element_style'];
	
	if (empty($params['menu'])) 
	{
		$smarty->trigger_error("please insert 'menu' parameter");
		exit;
	}
	$menu_nav = $smarty->get_template_vars('menu');
	$home = $smarty->get_template_vars('home');
	$home_id = $sessionObj->getHomePage_id();
	$menu_names = $smarty->get_template_vars('menu_names');
	$_output = '';
    $_output .= '<ul class="'.$ul_style.'">';
	
	if ($home_id==0)
		$menu_names = array();
	
	if(!is_bool(array_search($menu,$menu_names)))	
	{
		if (count($menu_nav[$menu]) != 0)
		{
			foreach ($menu_nav[$menu] as $menu_name)
			{
				
				//verifica che l'elemento da visualizzare non sia l'elemento corrente
				if ($menu_name['current']!=true)
		 		{
				
					//if($home_id==$menu_name['s_topic_id'])
					//{
						$_output .='<li>';
						$_output .='<a href="'.$menu_name['url'].'"title="';
						$_output .=$menu_name['title'].'">'.$menu_name['label'].'</a>';
						$_output .='</li>';
					//}
					
					/*elseif($home!=true)
					{
				   		$_output .='<li>';
						$_output .='<a href="'.$menu_name['url'].'"title="';
						$_output .=$menu_name['title'].'">'.$menu_name['label'].'</a>';
						$_output .='</li>';
					}*/
				}
		 		else
		 		{
				
		 			//if($home!=true & $home_id!=$menu_nav['id'])
					//{
		 				 $_output .='<li>';
						 $_output .='<a href="'.$menu_name['url'].'"title="'.$menu_name['title'].'"'; 
						$_output .='class="'.$current_element_style.'">'.$menu_name['label'].'</a>';
						$_output .='</li>';
		 			//}
				} 
			}
		}
	  	else
		 	$_output .='<li>The element of the menu are not available</li>';
	}
	else
		 $_output .='<li>The current menu is not available</li>';
	$_output .='</ul>';
    return $_output;
}

?>
