<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {load_structural_links} function plugin
 *
 * File:       function.load_structural_links.php<br>
 * Type:       function<br>
 * Name:       load_structural_links<br>
 * Date:       18.May.2007<br>
 * Purpose:    Prints out all the structural links of the current dialogue act<br>

 * Input:<br>
*  - active_element_style		(optional) - string that indicates the style class of the active 										 element of the menu
*   - ul_style     			    (optional) - string that indicates the style class of the 																									                                             'ul' tag element 				                                            
 

 * Examples:
  * {load_structural_links}


 * @author     Gabriele Perego - Stefano Sormani
 * @version    1.0
 */
 
function smarty_function_load_structural_links($params, &$smarty)
{
    	$active =$params['active_element_style'];
		$ul_class = $params['ul_style'];
		$structuralLinks = $smarty->get_template_vars('structuralLinks');
		$_output .='';
		if (count ($structuralLinks) ==1)
		{
		return $_output;
		}
		$_output .='<ul class="'.$ul_class.'">';
		
		foreach ($structuralLinks as $structuralLink)
		{
			if ($structuralLink['current'])
		 	{
				$_output .='<li><a class="'.$active.'" href="'.$structuralLink['url'].'"';
				$_output .='title="'.$structuralLink['label'].'">';
				$_output .=$structuralLink['label'].'</a></li>';
			}
			else
			{
				$_output .='<li><a href="'.$structuralLink['url'].'"';
				$_output .='title="'.$structuralLink['label'].'">';
				$_output .=$structuralLink['label'].'</a></li>';
			}
		}
		$_output .='</ul>';
	 
   		return $_output;
}

?>
