<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {load_ta_links} function plugin
 *
 * File:       function.load.ta_links.php<br>
 * Type:       function<br>
 * Name:       load_ta_links<br>
 * Date:       21.May.2007<br>
 * Purpose:    Prints out all the links related to the transition act<br>
 * Input:<br>
 * - a_style     			(optional) - string that indicates the style class of the 'a' 				                                         tag element related to each link
 
 * Examples:
 * {load_ta_links}
 

 * @author     Gabriele Perego - Stefano Sormani
 * @version    1.0
 */
	
function smarty_function_load_ta_links($param, &$smarty)
{
	$ta_links = $smarty->get_template_vars('ta_links');
	$link_style =$param['link_style'];
	$_output = '';
	
	foreach ($ta_links as $ta_link)
	{
	//print_r($ta_links);
		$_output .='<a class="'.$link_style.'" href="'.$ta_link[url].'"';
		$_output .='title="'.$ta_link[label].'">'.$ta_link[label].'</a><br />';
	}
	
    return $_output;
}
?>
