<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {load_transition_links} function plugin
 *
 * File:       function.load.transition_links.php<br>
 * Type:       function<br>
 * Name:       load_ia_links<br>
 * Date:       21.May.2007<br>
 * Purpose:    Prints out all the transition links related to the introductory act<br>

 * Input:<br>
 * - ta_name					(optional) - string that indicates the name of the                                             transition act that you want to visualize. If 										     the parameter is non specified, the function 					 											 prints out all the transition act referred to 											 the current multiple topic 	
 * - transitionLinks_box		(optional) - string that indicates the style class of the 																									                                             'div' tag element that include all the 				                                             structural link 		
 * - relation_title             (optional) - string that indicates the style class of the 																									                                             title of the transition link 
 * - link_style            		(optional) - string that indicates the style class of the 																									                                             'a' tag element that refers to the link of 		                                             the transition link 	                  
 * Examples:
 * {load_transition_links}
 
 * @author     Gabriele Perego - Stefano Sormani
 * @version    1.0
 */
	
function smarty_function_load_transition_links($param, &$smarty)
{
    $transition_act_info = $smarty->get_template_vars('transition_act_info');
	
	$transition_links = $smarty->get_template_vars('transition_links');
	$transitionLinks_box = $param['transitionLinks_box'];
	$ta_name = $param['ta_name'];
	$relation_title = $param['relation_title'];
	$introduction = $param['introduction'];
	$link_style = $param['link_style'];
	$_output = '';
	$_output1 = '';
	if (count ($transition_links) !=0)
	{
		if (!empty($ta_name))
		{
			if(array_key_exists($ta_name,$transition_act_info))
			{
				if(count ($transition_act_info[$ta_name]) !=0)
				{
					$_output1 .='<div id="'.$transitionLinks_box.'">';
					
					foreach ($transition_act_info as $thing => $transition_act)
					{
					
						if (!strcmp($thing,$ta_name))
						{
							if ($transition_act['mode'] =="direct_transition")
							{
								$_output1 .='<span class="'.$relation_title.'">'.$transition_act['relation_title'].'</span>';
								if ($transition_act['introductory_text']!="")
									$_output1 .='<span class="'.$introduction.'">'.$transition_act['introductory_text'].'</span>';
							}
							else 
							{
								$_output1 .='<a class="'.$link_style.'" href="'.$transition_act['url'].'&mt_id='.$transition_act['from_topic_id'].'"';
								$_output1 .='title="'.$transition_act['relation_title'].'">';
								$_output1 .=$transition_act['relation_title'].'</a>';
								$_output1 .='</div>';
								$_output .= $_output1;
								return $_output;
							}
						}
					}
					foreach ($transition_links[$ta_name] as $tl_link)
					{
						if ($tl_link['label']!="")
						{
							$_output1 .='<a class="'.$link_style.'" href="'.$tl_link['url'].'"';
							$_output1 .='title="'.$tl_link['label'].'">';
							$_output1 .=$tl_link['label'].'</a>';
						}
						else
						{
							$_output1 .='<span class="'.$introduction.'">no name</span>';
						}
					}
					$_output1 .='</div>';
				}
			}
			else
			{
				$_output1 .='<div id="'.$transitionLinks_box.'">';
				$_output1 .='The transition act is not available';
				$_output1 .='</div>';
			}
		}
		else
		{
			foreach ($transition_act_info as $thing => $transition_act)
			{
				
				if (count ( $transition_act) !=0 )
				{
					$_output1 .='<div id="'.$transitionLinks_box.'">';
					if ($transition_act['mode'] =="direct_transition")
					{
						$_output1 .='<span class="'.$relation_title.'">'.$transition_act['relation_title'].'</span>';
						if ($transition_act['introductory_text']!="")
							$_output1 .='<span class="'.$introduction.'">'.$transition_act['introductory_text'].'</span>';
					}
					else 
					{
						$_output1 .='<a class="'.$link_style.'" href="'.$transition_act['url'].'&mt_id='.$transition_act['from_topic_id'].'"';
						$_output1 .='title="'.$transition_act['relation_title'].'">';
						$_output1 .=$transition_act['relation_title'].'</a>';
						$_output1 .='</div>';
						continue 1;
					}
					foreach ($transition_links[$thing] as $tl_link)
					{
						if ($tl_link['label']!="")
						{
							$_output1 .='<a class="'.$link_style.'" href="'.$tl_link['url'].'"';
							$_output1 .='title="'.$tl_link['label'].'">';
							$_output1 .=$tl_link['label'].'</a>';
						}
						else
						{
							$_output1 .='<span class="'.$introduction.'">no name</span>';
						}
					}
					$_output1 .='</div>';
				}	
			}
		}
	}
	$_output .= $_output1;
	return $_output;
}


	
		

?>
